
/* GENERATED CODE */

#include <stdlib.h> /* qsort */
#include <assert.h> /* assert */
#include <string.h> /* memset/memcpy */
#include "tetra.h"
#define MAX_PATTERNS 32

typedef struct Tetra_Pattern_struct {
    ulongint    size, value, space, interval;
    int         read_only, close, during, index, score;
} Tetra_Pattern;

static int Sort_By_Value (const void * a, const void * b)
{
    const Tetra_Pattern * tpa = (const Tetra_Pattern *) a;
    const Tetra_Pattern * tpb = (const Tetra_Pattern *) b;
    if (tpa->score < tpb->score) {
        return -1;
    } else if (tpa->score > tpb->score) {
        return 1;
    } else if (tpa->index < tpb->index) {
        return -1;
    } else if (tpa->index > tpb->index) {
        return 1;
    } else {
        return 0;
    }
}

static void Ready_Patterns(Tetra_Params * tp,
            Tetra_Pattern * pattern_setup,
            Tetra_Pattern * pattern, int count)
{
    void * cb = tp->mem_model_cb;
    ulongint space = 0;
    ulongint i;

    memset(pattern, 0, sizeof(Tetra_Pattern) * MAX_PATTERNS);
    qsort(pattern_setup, count, sizeof(Tetra_Pattern), Sort_By_Value);

    for (i = 0; i < count; i++) {
        Tetra_Pattern * p = &pattern_setup[ i ];
        ulongint test = p->value;
        p->space = space;
        if (p->score < 0) {
            p->value = tp->open_fn(cb, p->value,
                    p->size, &space, p->read_only);
        }
        if (p->value != test) {
            p->close = 1;
            if (!tp->page_flag) {
                p->during = 1;
            }
        }
        assert(0 <= p->index);
        assert(p->index < count);
        memcpy(&pattern[ p->index ], p, sizeof(Tetra_Pattern));
    }
}

/* END INITIAL CODE */


static void adpcm_113_112_114(Tetra_Params * tp) {
    void * cb = tp->mem_model_cb;

    /* initialisation */
    ulongint i;
    ulongint read_only_remaining = tp->ro_max;
    Tetra_Pattern pattern_setup[ MAX_PATTERNS ];
    Tetra_Pattern pattern[ MAX_PATTERNS ];
    memset (pattern_setup, 0, sizeof(Tetra_Pattern) * MAX_PATTERNS);
    assert ( MAX_PATTERNS >= 3 ) ;
    
    /* initialise pattern 1 */
    i = 1;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 1) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = (loop_size * 2);
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 40000);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
        p->interval = tp->tile_size / 2; /* abs(a.step) */
        if (p->interval == 0) p->interval = 1;
    }
    /* initialise pattern 2 */
    i = 2;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 2; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 404;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 404);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 0 */
    i = 0;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (0 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 1) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = (loop_size * 1);
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 20000);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
        p->interval = tp->tile_size / 1; /* abs(a.step) */
        if (p->interval == 0) p->interval = 1;
    }
    Ready_Patterns(tp, pattern_setup, pattern, 3);
    /* start */
    for (i = 0; i < tp->loop_size; i++) {
        Tetra_Pattern * p = NULL;
        int newloc;
                
/* operations */
tp->read_fn(cb, pattern[ 2 ].value + tp->random_fn(tp, 404), "indexTable: Random, within 404, count 2");
tp->read_fn(cb, pattern[ 1 ].value + (i * 2), "inp: Linear, count 1, step 2");
tp->read_fn(cb, pattern[ 2 ].value + tp->random_fn(tp, 404), "indexTable: Random, within 404, count 2");
tp->write_fn(cb, pattern[ 0 ].value + (i * 1), "outp: Linear, count 1, step 1");
tp->do_tick_fn(tp, TICK_LOOP_OVERHEAD);

/* generate pattern 0 */
p = &pattern[ 0 ];
newloc = tp->tiling_flag && ((i % p->interval) == (p->interval - 1));

        if (newloc) {
            if (p->during) {
                p->value = tp->close_fn(cb, p->value);
            }
            if (p->during) {
                int64_t offset = tp->tiling_flag ? ((int64_t) (i+1) * 1) : 0;
                ulongint space = p->space;
                p->value = tp->open_fn(cb, p->value + offset,
                        p->size, &space, p->read_only) - offset;
            }
        } /* if (newloc) */
/* generate pattern 1 */
p = &pattern[ 1 ];
newloc = tp->tiling_flag && ((i % p->interval) == (p->interval - 1));

        if (newloc) {
            if (p->during) {
                p->value = tp->close_fn(cb, p->value);
            }
            if (p->during) {
                int64_t offset = tp->tiling_flag ? ((int64_t) (i+1) * 2) : 0;
                ulongint space = p->space;
                p->value = tp->open_fn(cb, p->value + offset,
                        p->size, &space, p->read_only) - offset;
            }
        } /* if (newloc) */
/* generate pattern 2 */
p = &pattern[ 2 ];
newloc = 0;

    } /* for */
   
    for (i = 0; i < 3; i++) {
        if (pattern[i].close) {
            tp->close_fn(cb, pattern[i].value);
        }
    }
} /* function */
/* adpcm,adpcm_coder, 2R[404] 1S+1* 1S+2*/



static void ammp_61_59(Tetra_Params * tp) {
    void * cb = tp->mem_model_cb;

    /* initialisation */
    ulongint i;
    ulongint read_only_remaining = tp->ro_max;
    Tetra_Pattern pattern_setup[ MAX_PATTERNS ];
    Tetra_Pattern pattern[ MAX_PATTERNS ];
    memset (pattern_setup, 0, sizeof(Tetra_Pattern) * MAX_PATTERNS);
    assert ( MAX_PATTERNS >= 2 ) ;
    
    /* initialise pattern 1 */
    i = 1;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 3; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 16;
        }
        if (!1) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 16);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 0 */
    i = 0;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 5; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (0 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 65536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    Ready_Patterns(tp, pattern_setup, pattern, 2);
    /* start */
    for (i = 0; i < tp->loop_size; i++) {
        Tetra_Pattern * p = NULL;
        int newloc;
                
/* operations */
tp->read_fn(cb, pattern[ 0 ].value + 0, "atomUPDATE: Static, count 5");
tp->read_fn(cb, pattern[ 1 ].value + 12, "ATOM.next&serial: LinkedList: size 16, count 3");
tp->read_fn(cb, pattern[ 0 ].value + 0, "atomUPDATE: Static, count 5");
tp->read_fn(cb, pattern[ 1 ].value + 1, "ATOM.next&serial: LinkedList: size 16, count 3");
tp->read_fn(cb, pattern[ 0 ].value + 0, "atomUPDATE: Static, count 5");
tp->read_fn(cb, pattern[ 0 ].value + 0, "atomUPDATE: Static, count 5");
tp->read_fn(cb, pattern[ 1 ].value + 10, "ATOM.next&serial: LinkedList: size 16, count 3");
tp->write_fn(cb, pattern[ 0 ].value + 0, "atomUPDATE: Static, count 5");
tp->do_tick_fn(tp, TICK_LOOP_OVERHEAD);

/* generate pattern 0 */
p = &pattern[ 0 ];
newloc = 0;

/* generate pattern 1 */
p = &pattern[ 1 ];
newloc = 1;

        if (newloc) {
            if (p->during) {
                p->value = tp->close_fn(cb, p->value);
            }
            p->value = tp->new_fn(tp, p->value, 16);
            
            if (p->during) {
                int64_t offset = tp->tiling_flag ? ((int64_t) (i+1) * 0) : 0;
                ulongint space = p->space;
                p->value = tp->open_fn(cb, p->value + offset,
                        p->size, &space, p->read_only) - offset;
            }
        } /* if (newloc) */
    } /* for */
   
    for (i = 0; i < 2; i++) {
        if (pattern[i].close) {
            tp->close_fn(cb, pattern[i].value);
        }
    }
} /* function */
/* ammp,a_m_serial, 5C* 3D*/



static void ammp_246_245(Tetra_Params * tp) {
    void * cb = tp->mem_model_cb;

    /* initialisation */
    ulongint i;
    ulongint read_only_remaining = tp->ro_max;
    Tetra_Pattern pattern_setup[ MAX_PATTERNS ];
    Tetra_Pattern pattern[ MAX_PATTERNS ];
    memset (pattern_setup, 0, sizeof(Tetra_Pattern) * MAX_PATTERNS);
    assert ( MAX_PATTERNS >= 2 ) ;
    
    /* initialise pattern 1 */
    i = 1;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 3; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 8;
        }
        if (!1) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 8);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 0 */
    i = 0;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 2; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (0 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 65536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    Ready_Patterns(tp, pattern_setup, pattern, 2);
    /* start */
    for (i = 0; i < tp->loop_size; i++) {
        Tetra_Pattern * p = NULL;
        int newloc;
                
/* operations */
tp->read_fn(cb, pattern[ 1 ].value + 0, "ATOM.next: LinkedList: size 8, count 3");
tp->read_fn(cb, pattern[ 1 ].value + 1, "ATOM.next: LinkedList: size 8, count 3");
tp->write_fn(cb, pattern[ 0 ].value + 0, "atomNUMBER: Static, count 2");
tp->read_fn(cb, pattern[ 0 ].value + 0, "atomNUMBER: Static, count 2");
tp->read_fn(cb, pattern[ 1 ].value + 3, "ATOM.next: LinkedList: size 8, count 3");
tp->do_tick_fn(tp, TICK_LOOP_OVERHEAD);

/* generate pattern 0 */
p = &pattern[ 0 ];
newloc = 0;

/* generate pattern 1 */
p = &pattern[ 1 ];
newloc = 1;

        if (newloc) {
            if (p->during) {
                p->value = tp->close_fn(cb, p->value);
            }
            p->value = tp->new_fn(tp, p->value, 8);
            
            if (p->during) {
                int64_t offset = tp->tiling_flag ? ((int64_t) (i+1) * 0) : 0;
                ulongint space = p->space;
                p->value = tp->open_fn(cb, p->value + offset,
                        p->size, &space, p->read_only) - offset;
            }
        } /* if (newloc) */
    } /* for */
   
    for (i = 0; i < 2; i++) {
        if (pattern[i].close) {
            tp->close_fn(cb, pattern[i].value);
        }
    }
} /* function */
/* ammp,a_number, 2C* 3D*/



static void art_122_121(Tetra_Params * tp) {
    void * cb = tp->mem_model_cb;

    /* initialisation */
    ulongint i;
    ulongint read_only_remaining = tp->ro_max;
    Tetra_Pattern pattern_setup[ MAX_PATTERNS ];
    Tetra_Pattern pattern[ MAX_PATTERNS ];
    memset (pattern_setup, 0, sizeof(Tetra_Pattern) * MAX_PATTERNS);
    assert ( MAX_PATTERNS >= 9 ) ;
    
    /* initialise pattern 6 */
    i = 6;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 1) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = (loop_size * 8);
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 160000);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
        p->interval = tp->tile_size / 8; /* abs(a.step) */
        if (p->interval == 0) p->interval = 1;
    }
    /* initialise pattern 7 */
    i = 7;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 1) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = (loop_size * 64);
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 1280000);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
        p->interval = tp->tile_size / 64; /* abs(a.step) */
        if (p->interval == 0) p->interval = 1;
    }
    /* initialise pattern 0 */
    i = 0;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 65536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 1 */
    i = 1;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 65536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 2 */
    i = 2;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 2; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 65536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 4 */
    i = 4;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 65536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 5 */
    i = 5;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 5; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 65536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 8 */
    i = 8;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 88;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 88);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 3 */
    i = 3;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 2; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (0 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 1) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = (loop_size * 1);
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 20000);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
        p->interval = tp->tile_size / 1; /* abs(a.step) */
        if (p->interval == 0) p->interval = 1;
    }
    Ready_Patterns(tp, pattern_setup, pattern, 9);
    /* start */
    for (i = 0; i < tp->loop_size; i++) {
        Tetra_Pattern * p = NULL;
        int newloc;
                
/* operations */
tp->read_fn(cb, pattern[ 8 ].value + tp->random_fn(tp, 88), "bus[ti][tj]: Random, within 88, count 1");
tp->read_fn(cb, pattern[ 5 ].value + 0, "huh: Literal");
tp->read_fn(cb, pattern[ 0 ].value + 0, "bus: Local, count 1");
tp->read_fn(cb, pattern[ 5 ].value + 0, "huh: Literal");
tp->write_fn(cb, pattern[ 3 ].value + (i * 1), "Y[tj].y: Linear, count 2, step 1");
tp->read_fn(cb, pattern[ 7 ].value + (i * 64), "f1_layer[ti].P: Linear, count 1, step 64");
tp->read_fn(cb, pattern[ 5 ].value + 0, "huh: Literal");
tp->read_fn(cb, pattern[ 3 ].value + (i * 1), "Y[tj].y: Linear, count 2, step 1");
tp->read_fn(cb, pattern[ 4 ].value + 0, "num1fs: Static, count 1");
tp->read_fn(cb, pattern[ 2 ].value + 0, "Y: Static, count 2");
tp->read_fn(cb, pattern[ 1 ].value + 0, "f1_layer: Static, count 1");
tp->read_fn(cb, pattern[ 5 ].value + 0, "huh: Literal");
tp->read_fn(cb, pattern[ 6 ].value + (i * 8), "bus[ti]: Linear, count 1, step 8");
tp->read_fn(cb, pattern[ 2 ].value + 0, "Y: Static, count 2");
tp->read_fn(cb, pattern[ 5 ].value + 0, "huh: Literal");
tp->do_tick_fn(tp, TICK_LOOP_OVERHEAD);

/* generate pattern 0 */
p = &pattern[ 0 ];
newloc = 0;

/* generate pattern 1 */
p = &pattern[ 1 ];
newloc = 0;

/* generate pattern 2 */
p = &pattern[ 2 ];
newloc = 0;

/* generate pattern 3 */
p = &pattern[ 3 ];
newloc = tp->tiling_flag && ((i % p->interval) == (p->interval - 1));

        if (newloc) {
            if (p->during) {
                p->value = tp->close_fn(cb, p->value);
            }
            if (p->during) {
                int64_t offset = tp->tiling_flag ? ((int64_t) (i+1) * 1) : 0;
                ulongint space = p->space;
                p->value = tp->open_fn(cb, p->value + offset,
                        p->size, &space, p->read_only) - offset;
            }
        } /* if (newloc) */
/* generate pattern 4 */
p = &pattern[ 4 ];
newloc = 0;

/* generate pattern 5 */
p = &pattern[ 5 ];
newloc = 0;

/* generate pattern 6 */
p = &pattern[ 6 ];
newloc = tp->tiling_flag && ((i % p->interval) == (p->interval - 1));

        if (newloc) {
            if (p->during) {
                p->value = tp->close_fn(cb, p->value);
            }
            if (p->during) {
                int64_t offset = tp->tiling_flag ? ((int64_t) (i+1) * 8) : 0;
                ulongint space = p->space;
                p->value = tp->open_fn(cb, p->value + offset,
                        p->size, &space, p->read_only) - offset;
            }
        } /* if (newloc) */
/* generate pattern 7 */
p = &pattern[ 7 ];
newloc = tp->tiling_flag && ((i % p->interval) == (p->interval - 1));

        if (newloc) {
            if (p->during) {
                p->value = tp->close_fn(cb, p->value);
            }
            if (p->during) {
                int64_t offset = tp->tiling_flag ? ((int64_t) (i+1) * 64) : 0;
                ulongint space = p->space;
                p->value = tp->open_fn(cb, p->value + offset,
                        p->size, &space, p->read_only) - offset;
            }
        } /* if (newloc) */
/* generate pattern 8 */
p = &pattern[ 8 ];
newloc = 0;

    } /* for */
   
    for (i = 0; i < 9; i++) {
        if (pattern[i].close) {
            tp->close_fn(cb, pattern[i].value);
        }
    }
} /* function */
/* art,train_match, 5C 1C 1C 2C 1C 1R[88] 1S+8 1S+64 2S+1**/



static void art_181_182_189_187_185(Tetra_Params * tp) {
    void * cb = tp->mem_model_cb;

    /* initialisation */
    ulongint i;
    ulongint read_only_remaining = tp->ro_max;
    Tetra_Pattern pattern_setup[ MAX_PATTERNS ];
    Tetra_Pattern pattern[ MAX_PATTERNS ];
    memset (pattern_setup, 0, sizeof(Tetra_Pattern) * MAX_PATTERNS);
    assert ( MAX_PATTERNS >= 9 ) ;
    
    /* initialise pattern 6 */
    i = 6;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 1) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = (loop_size * 8);
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 160000);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
        p->interval = tp->tile_size / 8; /* abs(a.step) */
        if (p->interval == 0) p->interval = 1;
    }
    /* initialise pattern 0 */
    i = 0;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 65536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 1 */
    i = 1;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 65536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 2 */
    i = 2;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 65536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 3 */
    i = 3;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 65536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 4 */
    i = 4;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 65536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 5 */
    i = 5;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 5; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 65536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 7 */
    i = 7;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1048576;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 1048576);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 8 */
    i = 8;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1048576;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 1048576);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    Ready_Patterns(tp, pattern_setup, pattern, 9);
    /* start */
    for (i = 0; i < tp->loop_size; i++) {
        Tetra_Pattern * p = NULL;
        int newloc;
                
/* operations */
tp->read_fn(cb, pattern[ 4 ].value + 0, "numf2s: Local, count 1");
tp->read_fn(cb, pattern[ 5 ].value + 0, "huh: Literal");
tp->read_fn(cb, pattern[ 3 ].value + 0, "d: Local, count 1");
tp->read_fn(cb, pattern[ 5 ].value + 0, "huh: Literal");
tp->read_fn(cb, pattern[ 5 ].value + 0, "huh: Literal");
tp->read_fn(cb, pattern[ 2 ].value + 0, "tds: Local, count 1");
tp->read_fn(cb, pattern[ 5 ].value + 0, "huh: Literal");
tp->read_fn(cb, pattern[ 1 ].value + 0, "Y: Static, count 1");
tp->read_fn(cb, pattern[ 0 ].value + 0, "winner: Static, count 1");
tp->read_fn(cb, pattern[ 8 ].value + tp->random_fn(tp, 1048576), "tds[ti][tj]: Random, within 1048576, count 1");
tp->read_fn(cb, pattern[ 5 ].value + 0, "huh: Literal");
tp->read_fn(cb, pattern[ 6 ].value + (i * 8), "tds[ti]: Linear, count 1, step 8");
tp->read_fn(cb, pattern[ 7 ].value + tp->random_fn(tp, 1048576), "Y[tj].y: Random, within 1048576, count 1");
tp->do_tick_fn(tp, TICK_LOOP_OVERHEAD);

/* generate pattern 0 */
p = &pattern[ 0 ];
newloc = 0;

/* generate pattern 1 */
p = &pattern[ 1 ];
newloc = 0;

/* generate pattern 2 */
p = &pattern[ 2 ];
newloc = 0;

/* generate pattern 3 */
p = &pattern[ 3 ];
newloc = 0;

/* generate pattern 4 */
p = &pattern[ 4 ];
newloc = 0;

/* generate pattern 5 */
p = &pattern[ 5 ];
newloc = 0;

/* generate pattern 6 */
p = &pattern[ 6 ];
newloc = tp->tiling_flag && ((i % p->interval) == (p->interval - 1));

        if (newloc) {
            if (p->during) {
                p->value = tp->close_fn(cb, p->value);
            }
            if (p->during) {
                int64_t offset = tp->tiling_flag ? ((int64_t) (i+1) * 8) : 0;
                ulongint space = p->space;
                p->value = tp->open_fn(cb, p->value + offset,
                        p->size, &space, p->read_only) - offset;
            }
        } /* if (newloc) */
/* generate pattern 7 */
p = &pattern[ 7 ];
newloc = 0;

/* generate pattern 8 */
p = &pattern[ 8 ];
newloc = 0;

    } /* for */
   
    for (i = 0; i < 9; i++) {
        if (pattern[i].close) {
            tp->close_fn(cb, pattern[i].value);
        }
    }
} /* function */
/* art,train_match, 5C 1C 1C 1C 1C 1C 1R[1.0M] 1R[1.0M] 1S+8*/



static void art_200_198_199(Tetra_Params * tp) {
    void * cb = tp->mem_model_cb;

    /* initialisation */
    ulongint i;
    ulongint read_only_remaining = tp->ro_max;
    Tetra_Pattern pattern_setup[ MAX_PATTERNS ];
    Tetra_Pattern pattern[ MAX_PATTERNS ];
    memset (pattern_setup, 0, sizeof(Tetra_Pattern) * MAX_PATTERNS);
    assert ( MAX_PATTERNS >= 6 ) ;
    
    /* initialise pattern 0 */
    i = 0;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 7; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 65536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 1 */
    i = 1;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 2; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 65536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 2 */
    i = 2;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 65536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 3 */
    i = 3;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 65536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 4 */
    i = 4;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 11; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 65536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 5 */
    i = 5;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 7; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (0 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 1) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = (loop_size * 64);
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 1280000);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
        p->interval = tp->tile_size / 64; /* abs(a.step) */
        if (p->interval == 0) p->interval = 1;
    }
    Ready_Patterns(tp, pattern_setup, pattern, 6);
    /* start */
    for (i = 0; i < tp->loop_size; i++) {
        Tetra_Pattern * p = NULL;
        int newloc;
                
/* operations */
tp->read_fn(cb, pattern[ 0 ].value + 0, "f1_layer: Static, count 7");
tp->read_fn(cb, pattern[ 1 ].value + 0, "theta: Static, count 2");
tp->read_fn(cb, pattern[ 0 ].value + 0, "f1_layer: Static, count 7");
tp->read_fn(cb, pattern[ 0 ].value + 0, "f1_layer: Static, count 7");
tp->read_fn(cb, pattern[ 0 ].value + 0, "f1_layer: Static, count 7");
tp->read_fn(cb, pattern[ 3 ].value + 0, "numf1s: Static, count 1");
tp->read_fn(cb, pattern[ 4 ].value + 0, "huh: Literal");
tp->read_fn(cb, pattern[ 0 ].value + 0, "f1_layer: Static, count 7");
tp->read_fn(cb, pattern[ 4 ].value + 0, "huh: Literal");
tp->read_fn(cb, pattern[ 4 ].value + 0, "huh: Literal");
tp->read_fn(cb, pattern[ 5 ].value + ((i * 64) + 45), "f1_layer[ti]: Struct, count 7, step 64");
tp->read_fn(cb, pattern[ 1 ].value + 0, "theta: Static, count 2");
tp->read_fn(cb, pattern[ 4 ].value + 0, "huh: Literal");
tp->read_fn(cb, pattern[ 5 ].value + ((i * 64) + 62), "f1_layer[ti]: Struct, count 7, step 64");
tp->write_fn(cb, pattern[ 5 ].value + ((i * 64) + 1), "f1_layer[ti]: Struct, count 7, step 64");
tp->read_fn(cb, pattern[ 0 ].value + 0, "f1_layer: Static, count 7");
tp->read_fn(cb, pattern[ 4 ].value + 0, "huh: Literal");
tp->read_fn(cb, pattern[ 4 ].value + 0, "huh: Literal");
tp->read_fn(cb, pattern[ 5 ].value + ((i * 64) + 2), "f1_layer[ti]: Struct, count 7, step 64");
tp->read_fn(cb, pattern[ 2 ].value + 0, "b: Static, count 1");
tp->read_fn(cb, pattern[ 4 ].value + 0, "huh: Literal");
tp->read_fn(cb, pattern[ 5 ].value + ((i * 64) + 37), "f1_layer[ti]: Struct, count 7, step 64");
tp->read_fn(cb, pattern[ 4 ].value + 0, "huh: Literal");
tp->read_fn(cb, pattern[ 0 ].value + 0, "f1_layer: Static, count 7");
tp->read_fn(cb, pattern[ 4 ].value + 0, "huh: Literal");
tp->read_fn(cb, pattern[ 5 ].value + ((i * 64) + 10), "f1_layer[ti]: Struct, count 7, step 64");
tp->read_fn(cb, pattern[ 4 ].value + 0, "huh: Literal");
tp->read_fn(cb, pattern[ 5 ].value + ((i * 64) + 25), "f1_layer[ti]: Struct, count 7, step 64");
tp->read_fn(cb, pattern[ 4 ].value + 0, "huh: Literal");
tp->do_tick_fn(tp, TICK_LOOP_OVERHEAD);

/* generate pattern 0 */
p = &pattern[ 0 ];
newloc = 0;

/* generate pattern 1 */
p = &pattern[ 1 ];
newloc = 0;

/* generate pattern 2 */
p = &pattern[ 2 ];
newloc = 0;

/* generate pattern 3 */
p = &pattern[ 3 ];
newloc = 0;

/* generate pattern 4 */
p = &pattern[ 4 ];
newloc = 0;

/* generate pattern 5 */
p = &pattern[ 5 ];
newloc = tp->tiling_flag && ((i % p->interval) == (p->interval - 1));

        if (newloc) {
            if (p->during) {
                p->value = tp->close_fn(cb, p->value);
            }
            if (p->during) {
                int64_t offset = tp->tiling_flag ? ((int64_t) (i+1) * 64) : 0;
                ulongint space = p->space;
                p->value = tp->open_fn(cb, p->value + offset,
                        p->size, &space, p->read_only) - offset;
            }
        } /* if (newloc) */
    } /* for */
   
    for (i = 0; i < 6; i++) {
        if (pattern[i].close) {
            tp->close_fn(cb, pattern[i].value);
        }
    }
} /* function */
/* art,train_match, 11C 7C 2C 1C 1C 7S+64**/



static void art_190(Tetra_Params * tp) {
    void * cb = tp->mem_model_cb;

    /* initialisation */
    ulongint i;
    ulongint read_only_remaining = tp->ro_max;
    Tetra_Pattern pattern_setup[ MAX_PATTERNS ];
    Tetra_Pattern pattern[ MAX_PATTERNS ];
    memset (pattern_setup, 0, sizeof(Tetra_Pattern) * MAX_PATTERNS);
    assert ( MAX_PATTERNS >= 3 ) ;
    
    /* initialise pattern 0 */
    i = 0;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 5; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 65536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 1 */
    i = 1;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 5; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 65536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 2 */
    i = 2;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 5; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (0 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 1) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = (loop_size * 64);
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 1280000);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
        p->interval = tp->tile_size / 64; /* abs(a.step) */
        if (p->interval == 0) p->interval = 1;
    }
    Ready_Patterns(tp, pattern_setup, pattern, 3);
    /* start */
    for (i = 0; i < tp->loop_size; i++) {
        Tetra_Pattern * p = NULL;
        int newloc;
                
/* operations */
tp->read_fn(cb, pattern[ 2 ].value + ((i * 64) + 39), "f1_layer: Struct, count 5, step 64");
tp->read_fn(cb, pattern[ 0 ].value + 0, "f1_layer: Static, count 5");
tp->read_fn(cb, pattern[ 1 ].value + 0, "huh: Literal");
tp->write_fn(cb, pattern[ 2 ].value + ((i * 64) + 0), "f1_layer: Struct, count 5, step 64");
tp->read_fn(cb, pattern[ 2 ].value + ((i * 64) + 7), "f1_layer: Struct, count 5, step 64");
tp->read_fn(cb, pattern[ 1 ].value + 0, "huh: Literal");
tp->read_fn(cb, pattern[ 1 ].value + 0, "huh: Literal");
tp->read_fn(cb, pattern[ 0 ].value + 0, "f1_layer: Static, count 5");
tp->read_fn(cb, pattern[ 2 ].value + ((i * 64) + 48), "f1_layer: Struct, count 5, step 64");
tp->read_fn(cb, pattern[ 2 ].value + ((i * 64) + 15), "f1_layer: Struct, count 5, step 64");
tp->read_fn(cb, pattern[ 0 ].value + 0, "f1_layer: Static, count 5");
tp->read_fn(cb, pattern[ 1 ].value + 0, "huh: Literal");
tp->read_fn(cb, pattern[ 0 ].value + 0, "f1_layer: Static, count 5");
tp->read_fn(cb, pattern[ 0 ].value + 0, "f1_layer: Static, count 5");
tp->read_fn(cb, pattern[ 1 ].value + 0, "huh: Literal");
tp->do_tick_fn(tp, TICK_LOOP_OVERHEAD);

/* generate pattern 0 */
p = &pattern[ 0 ];
newloc = 0;

/* generate pattern 1 */
p = &pattern[ 1 ];
newloc = 0;

/* generate pattern 2 */
p = &pattern[ 2 ];
newloc = tp->tiling_flag && ((i % p->interval) == (p->interval - 1));

        if (newloc) {
            if (p->during) {
                p->value = tp->close_fn(cb, p->value);
            }
            if (p->during) {
                int64_t offset = tp->tiling_flag ? ((int64_t) (i+1) * 64) : 0;
                ulongint space = p->space;
                p->value = tp->open_fn(cb, p->value + offset,
                        p->size, &space, p->read_only) - offset;
            }
        } /* if (newloc) */
    } /* for */
   
    for (i = 0; i < 3; i++) {
        if (pattern[i].close) {
            tp->close_fn(cb, pattern[i].value);
        }
    }
} /* function */
/* art,train_match, 5C 5C 5S+64**/



static void art_133_132(Tetra_Params * tp) {
    void * cb = tp->mem_model_cb;

    /* initialisation */
    ulongint i;
    ulongint read_only_remaining = tp->ro_max;
    Tetra_Pattern pattern_setup[ MAX_PATTERNS ];
    Tetra_Pattern pattern[ MAX_PATTERNS ];
    memset (pattern_setup, 0, sizeof(Tetra_Pattern) * MAX_PATTERNS);
    assert ( MAX_PATTERNS >= 7 ) ;
    
    /* initialise pattern 0 */
    i = 0;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 65536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 1 */
    i = 1;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 5; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 65536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 2 */
    i = 2;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 65536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 3 */
    i = 3;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 65536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 4 */
    i = 4;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 8; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 65536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 6 */
    i = 6;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1048576;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 1048576);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 5 */
    i = 5;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 5; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (0 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 1) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = (loop_size * 64);
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 1280000);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
        p->interval = tp->tile_size / 64; /* abs(a.step) */
        if (p->interval == 0) p->interval = 1;
    }
    Ready_Patterns(tp, pattern_setup, pattern, 7);
    /* start */
    for (i = 0; i < tp->loop_size; i++) {
        Tetra_Pattern * p = NULL;
        int newloc;
                
/* operations */
tp->read_fn(cb, pattern[ 4 ].value + 0, "huh: Literal");
tp->read_fn(cb, pattern[ 5 ].value + ((i * 64) + 51), "f1_layer: Struct, count 5, step 64");
tp->read_fn(cb, pattern[ 4 ].value + 0, "huh: Literal");
tp->read_fn(cb, pattern[ 6 ].value + tp->random_fn(tp, 1048576), "I[cp]: Random, within 1048576, count 1");
tp->read_fn(cb, pattern[ 5 ].value + ((i * 64) + 14), "f1_layer: Struct, count 5, step 64");
tp->write_fn(cb, pattern[ 5 ].value + ((i * 64) + 62), "f1_layer: Struct, count 5, step 64");
tp->read_fn(cb, pattern[ 0 ].value + 0, "cp: Static, count 1");
tp->read_fn(cb, pattern[ 1 ].value + 0, "f1_layer: Static, count 5");
tp->read_fn(cb, pattern[ 5 ].value + ((i * 64) + 41), "f1_layer: Struct, count 5, step 64");
tp->read_fn(cb, pattern[ 3 ].value + 0, "a: Static, count 1");
tp->read_fn(cb, pattern[ 4 ].value + 0, "huh: Literal");
tp->read_fn(cb, pattern[ 1 ].value + 0, "f1_layer: Static, count 5");
tp->read_fn(cb, pattern[ 5 ].value + ((i * 64) + 33), "f1_layer: Struct, count 5, step 64");
tp->read_fn(cb, pattern[ 1 ].value + 0, "f1_layer: Static, count 5");
tp->read_fn(cb, pattern[ 4 ].value + 0, "huh: Literal");
tp->read_fn(cb, pattern[ 4 ].value + 0, "huh: Literal");
tp->read_fn(cb, pattern[ 1 ].value + 0, "f1_layer: Static, count 5");
tp->read_fn(cb, pattern[ 1 ].value + 0, "f1_layer: Static, count 5");
tp->read_fn(cb, pattern[ 4 ].value + 0, "huh: Literal");
tp->read_fn(cb, pattern[ 2 ].value + 0, "numf1s: Static, count 1");
tp->read_fn(cb, pattern[ 4 ].value + 0, "huh: Literal");
tp->read_fn(cb, pattern[ 4 ].value + 0, "huh: Literal");
tp->do_tick_fn(tp, TICK_LOOP_OVERHEAD);

/* generate pattern 0 */
p = &pattern[ 0 ];
newloc = 0;

/* generate pattern 1 */
p = &pattern[ 1 ];
newloc = 0;

/* generate pattern 2 */
p = &pattern[ 2 ];
newloc = 0;

/* generate pattern 3 */
p = &pattern[ 3 ];
newloc = 0;

/* generate pattern 4 */
p = &pattern[ 4 ];
newloc = 0;

/* generate pattern 5 */
p = &pattern[ 5 ];
newloc = tp->tiling_flag && ((i % p->interval) == (p->interval - 1));

        if (newloc) {
            if (p->during) {
                p->value = tp->close_fn(cb, p->value);
            }
            if (p->during) {
                int64_t offset = tp->tiling_flag ? ((int64_t) (i+1) * 64) : 0;
                ulongint space = p->space;
                p->value = tp->open_fn(cb, p->value + offset,
                        p->size, &space, p->read_only) - offset;
            }
        } /* if (newloc) */
/* generate pattern 6 */
p = &pattern[ 6 ];
newloc = 0;

    } /* for */
   
    for (i = 0; i < 7; i++) {
        if (pattern[i].close) {
            tp->close_fn(cb, pattern[i].value);
        }
    }
} /* function */
/* art,train_match, 8C 1C 5C 1C 1C 1R[1.0M] 5S+64**/



static void bitcount_55(Tetra_Params * tp) {
    void * cb = tp->mem_model_cb;

    /* initialisation */
    ulongint i;
    ulongint read_only_remaining = tp->ro_max;
    Tetra_Pattern pattern_setup[ MAX_PATTERNS ];
    Tetra_Pattern pattern[ MAX_PATTERNS ];
    memset (pattern_setup, 0, sizeof(Tetra_Pattern) * MAX_PATTERNS);
    assert ( MAX_PATTERNS >= 1 ) ;
    
    /* initialise pattern 0 */
    i = 0;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 8; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 16;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 16);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    Ready_Patterns(tp, pattern_setup, pattern, 1);
    /* start */
    for (i = 0; i < tp->loop_size; i++) {
        Tetra_Pattern * p = NULL;
        int newloc;
                
/* operations */
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 16), "bits[]: Random, within 16, count 8");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 16), "bits[]: Random, within 16, count 8");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 16), "bits[]: Random, within 16, count 8");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 16), "bits[]: Random, within 16, count 8");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 16), "bits[]: Random, within 16, count 8");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 16), "bits[]: Random, within 16, count 8");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 16), "bits[]: Random, within 16, count 8");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 16), "bits[]: Random, within 16, count 8");
tp->do_tick_fn(tp, TICK_LOOP_OVERHEAD);

/* generate pattern 0 */
p = &pattern[ 0 ];
newloc = 0;

    } /* for */
   
    for (i = 0; i < 1; i++) {
        if (pattern[i].close) {
            tp->close_fn(cb, pattern[i].value);
        }
    }
} /* function */
/* bitcount,ntbl_bitcount, 8R[16]*/



static void bitcount_47(Tetra_Params * tp) {
    void * cb = tp->mem_model_cb;

    /* initialisation */
    ulongint i;
    ulongint read_only_remaining = tp->ro_max;
    Tetra_Pattern pattern_setup[ MAX_PATTERNS ];
    Tetra_Pattern pattern[ MAX_PATTERNS ];
    memset (pattern_setup, 0, sizeof(Tetra_Pattern) * MAX_PATTERNS);
    assert ( MAX_PATTERNS >= 1 ) ;
    
    /* initialise pattern 0 */
    i = 0;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 16;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 16);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    Ready_Patterns(tp, pattern_setup, pattern, 1);
    /* start */
    for (i = 0; i < tp->loop_size; i++) {
        Tetra_Pattern * p = NULL;
        int newloc;
                
/* operations */
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 16), "bits[]: Random, within 16, count 1");
tp->do_tick_fn(tp, TICK_LOOP_OVERHEAD);

/* generate pattern 0 */
p = &pattern[ 0 ];
newloc = 0;

    } /* for */
   
    for (i = 0; i < 1; i++) {
        if (pattern[i].close) {
            tp->close_fn(cb, pattern[i].value);
        }
    }
} /* function */
/* bitcount,ntbl_bitcnt, 1R[16]*/



static void bitcount_45(Tetra_Params * tp) {
    void * cb = tp->mem_model_cb;

    /* initialisation */
    ulongint i;
    ulongint read_only_remaining = tp->ro_max;
    Tetra_Pattern pattern_setup[ MAX_PATTERNS ];
    Tetra_Pattern pattern[ MAX_PATTERNS ];
    memset (pattern_setup, 0, sizeof(Tetra_Pattern) * MAX_PATTERNS);
    assert ( MAX_PATTERNS >= 1 ) ;
    
    /* initialise pattern 0 */
    i = 0;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 1) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = (loop_size * 8);
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 160000);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
        p->interval = tp->tile_size / 8; /* abs(a.step) */
        if (p->interval == 0) p->interval = 1;
    }
    Ready_Patterns(tp, pattern_setup, pattern, 1);
    /* start */
    for (i = 0; i < tp->loop_size; i++) {
        Tetra_Pattern * p = NULL;
        int newloc;
                
/* operations */
tp->read_fn(cb, pattern[ 0 ].value + (i * 8), "pBitCntFunc[i]: Linear, count 1, step 8");
tp->do_tick_fn(tp, TICK_LOOP_OVERHEAD);

/* generate pattern 0 */
p = &pattern[ 0 ];
newloc = tp->tiling_flag && ((i % p->interval) == (p->interval - 1));

        if (newloc) {
            if (p->during) {
                p->value = tp->close_fn(cb, p->value);
            }
            if (p->during) {
                int64_t offset = tp->tiling_flag ? ((int64_t) (i+1) * 8) : 0;
                ulongint space = p->space;
                p->value = tp->open_fn(cb, p->value + offset,
                        p->size, &space, p->read_only) - offset;
            }
        } /* if (newloc) */
    } /* for */
   
    for (i = 0; i < 1; i++) {
        if (pattern[i].close) {
            tp->close_fn(cb, pattern[i].value);
        }
    }
} /* function */
/* bitcount,main, 1S+8*/



static void bitcount_54(Tetra_Params * tp) {
    void * cb = tp->mem_model_cb;

    /* initialisation */
    ulongint i;
    ulongint read_only_remaining = tp->ro_max;
    Tetra_Pattern pattern_setup[ MAX_PATTERNS ];
    Tetra_Pattern pattern[ MAX_PATTERNS ];
    memset (pattern_setup, 0, sizeof(Tetra_Pattern) * MAX_PATTERNS);
    assert ( MAX_PATTERNS >= 1 ) ;
    
    /* initialise pattern 0 */
    i = 0;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 4; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 256;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 256);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    Ready_Patterns(tp, pattern_setup, pattern, 1);
    /* start */
    for (i = 0; i < tp->loop_size; i++) {
        Tetra_Pattern * p = NULL;
        int newloc;
                
/* operations */
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 256), "bits[]: Random, within 256, count 4");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 256), "bits[]: Random, within 256, count 4");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 256), "bits[]: Random, within 256, count 4");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 256), "bits[]: Random, within 256, count 4");
tp->do_tick_fn(tp, TICK_LOOP_OVERHEAD);

/* generate pattern 0 */
p = &pattern[ 0 ];
newloc = 0;

    } /* for */
   
    for (i = 0; i < 1; i++) {
        if (pattern[i].close) {
            tp->close_fn(cb, pattern[i].value);
        }
    }
} /* function */
/* bitcount,BW_btbl_bitcount, 4R[256]*/



static void bitcount_53(Tetra_Params * tp) {
    void * cb = tp->mem_model_cb;

    /* initialisation */
    ulongint i;
    ulongint read_only_remaining = tp->ro_max;
    Tetra_Pattern pattern_setup[ MAX_PATTERNS ];
    Tetra_Pattern pattern[ MAX_PATTERNS ];
    memset (pattern_setup, 0, sizeof(Tetra_Pattern) * MAX_PATTERNS);
    assert ( MAX_PATTERNS >= 1 ) ;
    
    /* initialise pattern 0 */
    i = 0;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 4; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 256;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 256);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    Ready_Patterns(tp, pattern_setup, pattern, 1);
    /* start */
    for (i = 0; i < tp->loop_size; i++) {
        Tetra_Pattern * p = NULL;
        int newloc;
                
/* operations */
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 256), "bits[]: Random, within 256, count 4");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 256), "bits[]: Random, within 256, count 4");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 256), "bits[]: Random, within 256, count 4");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 256), "bits[]: Random, within 256, count 4");
tp->do_tick_fn(tp, TICK_LOOP_OVERHEAD);

/* generate pattern 0 */
p = &pattern[ 0 ];
newloc = 0;

    } /* for */
   
    for (i = 0; i < 1; i++) {
        if (pattern[i].close) {
            tp->close_fn(cb, pattern[i].value);
        }
    }
} /* function */
/* bitcount,AR_btbl_bitcount, 4R[256]*/



static void bzip2_404(Tetra_Params * tp) {
    void * cb = tp->mem_model_cb;

    /* initialisation */
    ulongint i;
    ulongint read_only_remaining = tp->ro_max;
    Tetra_Pattern pattern_setup[ MAX_PATTERNS ];
    Tetra_Pattern pattern[ MAX_PATTERNS ];
    memset (pattern_setup, 0, sizeof(Tetra_Pattern) * MAX_PATTERNS);
    assert ( MAX_PATTERNS >= 2 ) ;
    
    /* initialise pattern 0 */
    i = 0;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 1) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = (loop_size * 1);
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 20000);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
        p->interval = tp->tile_size / 1; /* abs(a.step) */
        if (p->interval == 0) p->interval = 1;
    }
    /* initialise pattern 1 */
    i = 1;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 12; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (0 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 65536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    Ready_Patterns(tp, pattern_setup, pattern, 2);
    /* start */
    for (i = 0; i < tp->loop_size; i++) {
        Tetra_Pattern * p = NULL;
        int newloc;
                
/* operations */
tp->read_fn(cb, pattern[ 1 ].value + 0, "spec_fd[fd]: Static, count 12");
tp->write_fn(cb, pattern[ 1 ].value + 0, "spec_fd[fd]: Static, count 12");
tp->read_fn(cb, pattern[ 0 ].value + (i * 1), "spec_fd[fd].buf: Linear, count 1, step 1");
tp->read_fn(cb, pattern[ 1 ].value + 0, "spec_fd[fd]: Static, count 12");
tp->read_fn(cb, pattern[ 1 ].value + 0, "spec_fd[fd]: Static, count 12");
tp->read_fn(cb, pattern[ 1 ].value + 0, "spec_fd[fd]: Static, count 12");
tp->read_fn(cb, pattern[ 1 ].value + 0, "spec_fd[fd]: Static, count 12");
tp->read_fn(cb, pattern[ 1 ].value + 0, "spec_fd[fd]: Static, count 12");
tp->read_fn(cb, pattern[ 1 ].value + 0, "spec_fd[fd]: Static, count 12");
tp->read_fn(cb, pattern[ 1 ].value + 0, "spec_fd[fd]: Static, count 12");
tp->read_fn(cb, pattern[ 1 ].value + 0, "spec_fd[fd]: Static, count 12");
tp->read_fn(cb, pattern[ 1 ].value + 0, "spec_fd[fd]: Static, count 12");
tp->read_fn(cb, pattern[ 1 ].value + 0, "spec_fd[fd]: Static, count 12");
tp->do_tick_fn(tp, TICK_LOOP_OVERHEAD);

/* generate pattern 0 */
p = &pattern[ 0 ];
newloc = tp->tiling_flag && ((i % p->interval) == (p->interval - 1));

        if (newloc) {
            if (p->during) {
                p->value = tp->close_fn(cb, p->value);
            }
            if (p->during) {
                int64_t offset = tp->tiling_flag ? ((int64_t) (i+1) * 1) : 0;
                ulongint space = p->space;
                p->value = tp->open_fn(cb, p->value + offset,
                        p->size, &space, p->read_only) - offset;
            }
        } /* if (newloc) */
/* generate pattern 1 */
p = &pattern[ 1 ];
newloc = 0;

    } /* for */
   
    for (i = 0; i < 2; i++) {
        if (pattern[i].close) {
            tp->close_fn(cb, pattern[i].value);
        }
    }
} /* function */
/* bzip2,spec_getc, 12C* 1S+1*/



static void bzip2_339(Tetra_Params * tp) {
    void * cb = tp->mem_model_cb;

    /* initialisation */
    ulongint i;
    ulongint read_only_remaining = tp->ro_max;
    Tetra_Pattern pattern_setup[ MAX_PATTERNS ];
    Tetra_Pattern pattern[ MAX_PATTERNS ];
    memset (pattern_setup, 0, sizeof(Tetra_Pattern) * MAX_PATTERNS);
    assert ( MAX_PATTERNS >= 3 ) ;
    
    /* initialise pattern 0 */
    i = 0;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 6; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = (6);
        }
        if (!1) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 6);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 1 */
    i = 1;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 6; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = (6);
        }
        if (!1) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 6);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 2 */
    i = 2;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 13; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 65536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    Ready_Patterns(tp, pattern_setup, pattern, 3);
    /* start */
    for (i = 0; i < tp->loop_size; i++) {
        Tetra_Pattern * p = NULL;
        int newloc;
                
/* operations */
tp->read_fn(cb, pattern[ 2 ].value + 0, "block: Static, count 13");
tp->read_fn(cb, pattern[ 2 ].value + 0, "block: Static, count 13");
tp->read_fn(cb, pattern[ 1 ].value + 5, "*block: Unrolled, count 6, step 1");
tp->read_fn(cb, pattern[ 2 ].value + 0, "block: Static, count 13");
tp->read_fn(cb, pattern[ 0 ].value + 3, "*block: Unrolled, count 6, step 1");
tp->read_fn(cb, pattern[ 1 ].value + 3, "*block: Unrolled, count 6, step 1");
tp->read_fn(cb, pattern[ 1 ].value + 1, "*block: Unrolled, count 6, step 1");
tp->read_fn(cb, pattern[ 2 ].value + 0, "block: Static, count 13");
tp->read_fn(cb, pattern[ 0 ].value + 0, "*block: Unrolled, count 6, step 1");
tp->read_fn(cb, pattern[ 2 ].value + 0, "block: Static, count 13");
tp->read_fn(cb, pattern[ 0 ].value + 1, "*block: Unrolled, count 6, step 1");
tp->read_fn(cb, pattern[ 1 ].value + 4, "*block: Unrolled, count 6, step 1");
tp->read_fn(cb, pattern[ 2 ].value + 0, "block: Static, count 13");
tp->read_fn(cb, pattern[ 1 ].value + 2, "*block: Unrolled, count 6, step 1");
tp->read_fn(cb, pattern[ 2 ].value + 0, "block: Static, count 13");
tp->read_fn(cb, pattern[ 2 ].value + 0, "block: Static, count 13");
tp->read_fn(cb, pattern[ 0 ].value + 5, "*block: Unrolled, count 6, step 1");
tp->read_fn(cb, pattern[ 1 ].value + 0, "*block: Unrolled, count 6, step 1");
tp->read_fn(cb, pattern[ 2 ].value + 0, "block: Static, count 13");
tp->read_fn(cb, pattern[ 2 ].value + 0, "block: Static, count 13");
tp->read_fn(cb, pattern[ 2 ].value + 0, "block: Static, count 13");
tp->read_fn(cb, pattern[ 2 ].value + 0, "block: Static, count 13");
tp->read_fn(cb, pattern[ 2 ].value + 0, "block: Static, count 13");
tp->read_fn(cb, pattern[ 0 ].value + 4, "*block: Unrolled, count 6, step 1");
tp->read_fn(cb, pattern[ 0 ].value + 2, "*block: Unrolled, count 6, step 1");
tp->do_tick_fn(tp, TICK_LOOP_OVERHEAD);

/* generate pattern 0 */
p = &pattern[ 0 ];
newloc = 1;

        if (newloc) {
            if (p->during) {
                p->value = tp->close_fn(cb, p->value);
            }
            p->value = tp->new_fn(tp, p->value, 6);
            
            if (p->during) {
                int64_t offset = tp->tiling_flag ? ((int64_t) (i+1) * 0) : 0;
                ulongint space = p->space;
                p->value = tp->open_fn(cb, p->value + offset,
                        p->size, &space, p->read_only) - offset;
            }
        } /* if (newloc) */
/* generate pattern 1 */
p = &pattern[ 1 ];
newloc = 1;

        if (newloc) {
            if (p->during) {
                p->value = tp->close_fn(cb, p->value);
            }
            p->value = tp->new_fn(tp, p->value, 6);
            
            if (p->during) {
                int64_t offset = tp->tiling_flag ? ((int64_t) (i+1) * 0) : 0;
                ulongint space = p->space;
                p->value = tp->open_fn(cb, p->value + offset,
                        p->size, &space, p->read_only) - offset;
            }
        } /* if (newloc) */
/* generate pattern 2 */
p = &pattern[ 2 ];
newloc = 0;

    } /* for */
   
    for (i = 0; i < 3; i++) {
        if (pattern[i].close) {
            tp->close_fn(cb, pattern[i].value);
        }
    }
} /* function */
/* bzip2,fullGtU, 13C 6D 6D*/



static void bzip2_340(Tetra_Params * tp) {
    void * cb = tp->mem_model_cb;

    /* initialisation */
    ulongint i;
    ulongint read_only_remaining = tp->ro_max;
    Tetra_Pattern pattern_setup[ MAX_PATTERNS ];
    Tetra_Pattern pattern[ MAX_PATTERNS ];
    memset (pattern_setup, 0, sizeof(Tetra_Pattern) * MAX_PATTERNS);
    assert ( MAX_PATTERNS >= 6 ) ;
    
    /* initialise pattern 0 */
    i = 0;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 4; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 1) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = (loop_size * 1);
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 20000);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
        p->interval = tp->tile_size / 1; /* abs(a.step) */
        if (p->interval == 0) p->interval = 1;
    }
    /* initialise pattern 1 */
    i = 1;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 4; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 1) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = (loop_size * 1);
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 20000);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
        p->interval = tp->tile_size / 1; /* abs(a.step) */
        if (p->interval == 0) p->interval = 1;
    }
    /* initialise pattern 2 */
    i = 2;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 4; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 1) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = (loop_size * 1);
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 20000);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
        p->interval = tp->tile_size / 1; /* abs(a.step) */
        if (p->interval == 0) p->interval = 1;
    }
    /* initialise pattern 3 */
    i = 3;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 4; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 1) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = (loop_size * 1);
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 20000);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
        p->interval = tp->tile_size / 1; /* abs(a.step) */
        if (p->interval == 0) p->interval = 1;
    }
    /* initialise pattern 4 */
    i = 4;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 16; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 65536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 5 */
    i = 5;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 16; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 65536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    Ready_Patterns(tp, pattern_setup, pattern, 6);
    /* start */
    for (i = 0; i < tp->loop_size; i++) {
        Tetra_Pattern * p = NULL;
        int newloc;
                
/* operations */
tp->read_fn(cb, pattern[ 3 ].value + (i * 1), "*quadrant: Linear, count 4, step 1");
tp->read_fn(cb, pattern[ 5 ].value + 0, "quadrant: Static, count 16");
tp->read_fn(cb, pattern[ 3 ].value + (i * 1), "*quadrant: Linear, count 4, step 1");
tp->read_fn(cb, pattern[ 4 ].value + 0, "block: Static, count 16");
tp->read_fn(cb, pattern[ 5 ].value + 0, "quadrant: Static, count 16");
tp->read_fn(cb, pattern[ 3 ].value + (i * 1), "*quadrant: Linear, count 4, step 1");
tp->read_fn(cb, pattern[ 4 ].value + 0, "block: Static, count 16");
tp->read_fn(cb, pattern[ 3 ].value + (i * 1), "*quadrant: Linear, count 4, step 1");
tp->read_fn(cb, pattern[ 4 ].value + 0, "block: Static, count 16");
tp->read_fn(cb, pattern[ 2 ].value + (i * 1), "*quadrant: Linear, count 4, step 1");
tp->read_fn(cb, pattern[ 5 ].value + 0, "quadrant: Static, count 16");
tp->read_fn(cb, pattern[ 5 ].value + 0, "quadrant: Static, count 16");
tp->read_fn(cb, pattern[ 2 ].value + (i * 1), "*quadrant: Linear, count 4, step 1");
tp->read_fn(cb, pattern[ 5 ].value + 0, "quadrant: Static, count 16");
tp->read_fn(cb, pattern[ 4 ].value + 0, "block: Static, count 16");
tp->read_fn(cb, pattern[ 5 ].value + 0, "quadrant: Static, count 16");
tp->read_fn(cb, pattern[ 4 ].value + 0, "block: Static, count 16");
tp->read_fn(cb, pattern[ 4 ].value + 0, "block: Static, count 16");
tp->read_fn(cb, pattern[ 4 ].value + 0, "block: Static, count 16");
tp->read_fn(cb, pattern[ 1 ].value + (i * 1), "*block: Linear, count 4, step 1");
tp->read_fn(cb, pattern[ 4 ].value + 0, "block: Static, count 16");
tp->read_fn(cb, pattern[ 0 ].value + (i * 1), "*block: Linear, count 4, step 1");
tp->read_fn(cb, pattern[ 5 ].value + 0, "quadrant: Static, count 16");
tp->read_fn(cb, pattern[ 1 ].value + (i * 1), "*block: Linear, count 4, step 1");
tp->read_fn(cb, pattern[ 1 ].value + (i * 1), "*block: Linear, count 4, step 1");
tp->read_fn(cb, pattern[ 4 ].value + 0, "block: Static, count 16");
tp->read_fn(cb, pattern[ 5 ].value + 0, "quadrant: Static, count 16");
tp->read_fn(cb, pattern[ 4 ].value + 0, "block: Static, count 16");
tp->read_fn(cb, pattern[ 1 ].value + (i * 1), "*block: Linear, count 4, step 1");
tp->read_fn(cb, pattern[ 0 ].value + (i * 1), "*block: Linear, count 4, step 1");
tp->read_fn(cb, pattern[ 4 ].value + 0, "block: Static, count 16");
tp->read_fn(cb, pattern[ 5 ].value + 0, "quadrant: Static, count 16");
tp->read_fn(cb, pattern[ 5 ].value + 0, "quadrant: Static, count 16");
tp->read_fn(cb, pattern[ 4 ].value + 0, "block: Static, count 16");
tp->read_fn(cb, pattern[ 0 ].value + (i * 1), "*block: Linear, count 4, step 1");
tp->read_fn(cb, pattern[ 5 ].value + 0, "quadrant: Static, count 16");
tp->read_fn(cb, pattern[ 4 ].value + 0, "block: Static, count 16");
tp->read_fn(cb, pattern[ 5 ].value + 0, "quadrant: Static, count 16");
tp->read_fn(cb, pattern[ 5 ].value + 0, "quadrant: Static, count 16");
tp->read_fn(cb, pattern[ 5 ].value + 0, "quadrant: Static, count 16");
tp->read_fn(cb, pattern[ 4 ].value + 0, "block: Static, count 16");
tp->read_fn(cb, pattern[ 5 ].value + 0, "quadrant: Static, count 16");
tp->read_fn(cb, pattern[ 2 ].value + (i * 1), "*quadrant: Linear, count 4, step 1");
tp->read_fn(cb, pattern[ 0 ].value + (i * 1), "*block: Linear, count 4, step 1");
tp->read_fn(cb, pattern[ 2 ].value + (i * 1), "*quadrant: Linear, count 4, step 1");
tp->read_fn(cb, pattern[ 4 ].value + 0, "block: Static, count 16");
tp->read_fn(cb, pattern[ 4 ].value + 0, "block: Static, count 16");
tp->read_fn(cb, pattern[ 5 ].value + 0, "quadrant: Static, count 16");
tp->do_tick_fn(tp, TICK_LOOP_OVERHEAD);

/* generate pattern 0 */
p = &pattern[ 0 ];
newloc = tp->tiling_flag && ((i % p->interval) == (p->interval - 1));

        if (newloc) {
            if (p->during) {
                p->value = tp->close_fn(cb, p->value);
            }
            if (p->during) {
                int64_t offset = tp->tiling_flag ? ((int64_t) (i+1) * 1) : 0;
                ulongint space = p->space;
                p->value = tp->open_fn(cb, p->value + offset,
                        p->size, &space, p->read_only) - offset;
            }
        } /* if (newloc) */
/* generate pattern 1 */
p = &pattern[ 1 ];
newloc = tp->tiling_flag && ((i % p->interval) == (p->interval - 1));

        if (newloc) {
            if (p->during) {
                p->value = tp->close_fn(cb, p->value);
            }
            if (p->during) {
                int64_t offset = tp->tiling_flag ? ((int64_t) (i+1) * 1) : 0;
                ulongint space = p->space;
                p->value = tp->open_fn(cb, p->value + offset,
                        p->size, &space, p->read_only) - offset;
            }
        } /* if (newloc) */
/* generate pattern 2 */
p = &pattern[ 2 ];
newloc = tp->tiling_flag && ((i % p->interval) == (p->interval - 1));

        if (newloc) {
            if (p->during) {
                p->value = tp->close_fn(cb, p->value);
            }
            if (p->during) {
                int64_t offset = tp->tiling_flag ? ((int64_t) (i+1) * 1) : 0;
                ulongint space = p->space;
                p->value = tp->open_fn(cb, p->value + offset,
                        p->size, &space, p->read_only) - offset;
            }
        } /* if (newloc) */
/* generate pattern 3 */
p = &pattern[ 3 ];
newloc = tp->tiling_flag && ((i % p->interval) == (p->interval - 1));

        if (newloc) {
            if (p->during) {
                p->value = tp->close_fn(cb, p->value);
            }
            if (p->during) {
                int64_t offset = tp->tiling_flag ? ((int64_t) (i+1) * 1) : 0;
                ulongint space = p->space;
                p->value = tp->open_fn(cb, p->value + offset,
                        p->size, &space, p->read_only) - offset;
            }
        } /* if (newloc) */
/* generate pattern 4 */
p = &pattern[ 4 ];
newloc = 0;

/* generate pattern 5 */
p = &pattern[ 5 ];
newloc = 0;

    } /* for */
   
    for (i = 0; i < 6; i++) {
        if (pattern[i].close) {
            tp->close_fn(cb, pattern[i].value);
        }
    }
} /* function */
/* bzip2,fullGtU, 16C 16C 4S+1 4S+1 4S+1 4S+1*/



static void bzip2_406(Tetra_Params * tp) {
    void * cb = tp->mem_model_cb;

    /* initialisation */
    ulongint i;
    ulongint read_only_remaining = tp->ro_max;
    Tetra_Pattern pattern_setup[ MAX_PATTERNS ];
    Tetra_Pattern pattern[ MAX_PATTERNS ];
    memset (pattern_setup, 0, sizeof(Tetra_Pattern) * MAX_PATTERNS);
    assert ( MAX_PATTERNS >= 2 ) ;
    
    /* initialise pattern 0 */
    i = 0;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 1) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = (loop_size * 1);
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 20000);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
        p->interval = tp->tile_size / 1; /* abs(a.step) */
        if (p->interval == 0) p->interval = 1;
    }
    /* initialise pattern 1 */
    i = 1;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 13; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (0 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 65536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    Ready_Patterns(tp, pattern_setup, pattern, 2);
    /* start */
    for (i = 0; i < tp->loop_size; i++) {
        Tetra_Pattern * p = NULL;
        int newloc;
                
/* operations */
tp->read_fn(cb, pattern[ 1 ].value + 0, "spec_fd[fd]: Static, count 13");
tp->read_fn(cb, pattern[ 1 ].value + 0, "spec_fd[fd]: Static, count 13");
tp->read_fn(cb, pattern[ 1 ].value + 0, "spec_fd[fd]: Static, count 13");
tp->read_fn(cb, pattern[ 0 ].value + (i * -1) + (tp->tiling_flag ?(tp->tile_size - 1) : 0), "spec_fd[fd].buf: Linear, count 1, step -1");
tp->read_fn(cb, pattern[ 1 ].value + 0, "spec_fd[fd]: Static, count 13");
tp->read_fn(cb, pattern[ 1 ].value + 0, "spec_fd[fd]: Static, count 13");
tp->read_fn(cb, pattern[ 1 ].value + 0, "spec_fd[fd]: Static, count 13");
tp->read_fn(cb, pattern[ 1 ].value + 0, "spec_fd[fd]: Static, count 13");
tp->read_fn(cb, pattern[ 1 ].value + 0, "spec_fd[fd]: Static, count 13");
tp->read_fn(cb, pattern[ 1 ].value + 0, "spec_fd[fd]: Static, count 13");
tp->read_fn(cb, pattern[ 1 ].value + 0, "spec_fd[fd]: Static, count 13");
tp->read_fn(cb, pattern[ 1 ].value + 0, "spec_fd[fd]: Static, count 13");
tp->read_fn(cb, pattern[ 1 ].value + 0, "spec_fd[fd]: Static, count 13");
tp->write_fn(cb, pattern[ 1 ].value + 0, "spec_fd[fd]: Static, count 13");
tp->do_tick_fn(tp, TICK_LOOP_OVERHEAD);

/* generate pattern 0 */
p = &pattern[ 0 ];
newloc = tp->tiling_flag && ((i % p->interval) == (p->interval - 1));

        if (newloc) {
            if (p->during) {
                p->value = tp->close_fn(cb, p->value);
            }
            if (p->during) {
                int64_t offset = tp->tiling_flag ? ((int64_t) (i+1) * -1) : 0;
                ulongint space = p->space;
                p->value = tp->open_fn(cb, p->value + offset,
                        p->size, &space, p->read_only) - offset;
            }
        } /* if (newloc) */
/* generate pattern 1 */
p = &pattern[ 1 ];
newloc = 0;

    } /* for */
   
    for (i = 0; i < 2; i++) {
        if (pattern[i].close) {
            tp->close_fn(cb, pattern[i].value);
        }
    }
} /* function */
/* bzip2,getRLEpair, 13C* 1S-1*/



static void bzip2_77(Tetra_Params * tp) {
    void * cb = tp->mem_model_cb;

    /* initialisation */
    ulongint i;
    ulongint read_only_remaining = tp->ro_max;
    Tetra_Pattern pattern_setup[ MAX_PATTERNS ];
    Tetra_Pattern pattern[ MAX_PATTERNS ];
    memset (pattern_setup, 0, sizeof(Tetra_Pattern) * MAX_PATTERNS);
    assert ( MAX_PATTERNS >= 9 ) ;
    
    /* initialise pattern 2 */
    i = 2;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 1) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = (loop_size * 1);
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 20000);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
        p->interval = tp->tile_size / 1; /* abs(a.step) */
        if (p->interval == 0) p->interval = 1;
    }
    /* initialise pattern 0 */
    i = 0;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 65536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 1 */
    i = 1;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 65536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 3 */
    i = 3;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 65536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 5 */
    i = 5;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 8; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 65536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 6 */
    i = 6;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 263;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 263);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 8 */
    i = 8;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 699987;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 699987);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 4 */
    i = 4;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (0 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 1) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = (loop_size * 1);
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 20000);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
        p->interval = tp->tile_size / 1; /* abs(a.step) */
        if (p->interval == 0) p->interval = 1;
    }
    /* initialise pattern 7 */
    i = 7;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 2; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (0 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1024;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 1024);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    Ready_Patterns(tp, pattern_setup, pattern, 9);
    /* start */
    for (i = 0; i < tp->loop_size; i++) {
        Tetra_Pattern * p = NULL;
        int newloc;
                
/* operations */
tp->read_fn(cb, pattern[ 0 ].value + 0, "zptr: Static, count 1");
tp->read_fn(cb, pattern[ 6 ].value + tp->random_fn(tp, 263), "*seqToUnseq: Random, within 263, count 1");
tp->read_fn(cb, pattern[ 5 ].value + 0, "huh: Literal");
tp->read_fn(cb, pattern[ 5 ].value + 0, "huh: Literal");
tp->read_fn(cb, pattern[ 5 ].value + 0, "huh: Literal");
tp->read_fn(cb, pattern[ 1 ].value + 0, "block: Static, count 1");
tp->read_fn(cb, pattern[ 7 ].value + tp->random_fn(tp, 1024), "*mtfFreq: Random, within 1024, count 2");
tp->read_fn(cb, pattern[ 5 ].value + 0, "huh: Literal");
tp->read_fn(cb, pattern[ 2 ].value + (i * 1), "zptr: Linear, count 1, step 1");
tp->read_fn(cb, pattern[ 5 ].value + 0, "huh: Literal");
tp->read_fn(cb, pattern[ 3 ].value + 0, "szptr: Static, count 1");
tp->write_fn(cb, pattern[ 4 ].value + (i * 1), "*szptr: Linear, count 1, step 1");
tp->read_fn(cb, pattern[ 5 ].value + 0, "huh: Literal");
tp->write_fn(cb, pattern[ 7 ].value + tp->random_fn(tp, 1024), "*mtfFreq: Random, within 1024, count 2");
tp->read_fn(cb, pattern[ 5 ].value + 0, "huh: Literal");
tp->read_fn(cb, pattern[ 5 ].value + 0, "huh: Literal");
tp->read_fn(cb, pattern[ 8 ].value + tp->random_fn(tp, 699987), "*block: Random, within 699987, count 1");
tp->do_tick_fn(tp, TICK_LOOP_OVERHEAD);

/* generate pattern 0 */
p = &pattern[ 0 ];
newloc = 0;

/* generate pattern 1 */
p = &pattern[ 1 ];
newloc = 0;

/* generate pattern 2 */
p = &pattern[ 2 ];
newloc = tp->tiling_flag && ((i % p->interval) == (p->interval - 1));

        if (newloc) {
            if (p->during) {
                p->value = tp->close_fn(cb, p->value);
            }
            if (p->during) {
                int64_t offset = tp->tiling_flag ? ((int64_t) (i+1) * 1) : 0;
                ulongint space = p->space;
                p->value = tp->open_fn(cb, p->value + offset,
                        p->size, &space, p->read_only) - offset;
            }
        } /* if (newloc) */
/* generate pattern 3 */
p = &pattern[ 3 ];
newloc = 0;

/* generate pattern 4 */
p = &pattern[ 4 ];
newloc = tp->tiling_flag && ((i % p->interval) == (p->interval - 1));

        if (newloc) {
            if (p->during) {
                p->value = tp->close_fn(cb, p->value);
            }
            if (p->during) {
                int64_t offset = tp->tiling_flag ? ((int64_t) (i+1) * 1) : 0;
                ulongint space = p->space;
                p->value = tp->open_fn(cb, p->value + offset,
                        p->size, &space, p->read_only) - offset;
            }
        } /* if (newloc) */
/* generate pattern 5 */
p = &pattern[ 5 ];
newloc = 0;

/* generate pattern 6 */
p = &pattern[ 6 ];
newloc = 0;

/* generate pattern 7 */
p = &pattern[ 7 ];
newloc = 0;

/* generate pattern 8 */
p = &pattern[ 8 ];
newloc = 0;

    } /* for */
   
    for (i = 0; i < 9; i++) {
        if (pattern[i].close) {
            tp->close_fn(cb, pattern[i].value);
        }
    }
} /* function */
/* bzip2,generateMTFValues, 8C 1C 1C 1C 1R[683.6k] 1R[263] 2R[1.0k]* 1S+1 1S+1**/



static void bzip2_312(Tetra_Params * tp) {
    void * cb = tp->mem_model_cb;

    /* initialisation */
    ulongint i;
    ulongint read_only_remaining = tp->ro_max;
    Tetra_Pattern pattern_setup[ MAX_PATTERNS ];
    Tetra_Pattern pattern[ MAX_PATTERNS ];
    memset (pattern_setup, 0, sizeof(Tetra_Pattern) * MAX_PATTERNS);
    assert ( MAX_PATTERNS >= 5 ) ;
    
    /* initialise pattern 2 */
    i = 2;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 1) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = (loop_size * 1);
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 20000);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
        p->interval = tp->tile_size / 1; /* abs(a.step) */
        if (p->interval == 0) p->interval = 1;
    }
    /* initialise pattern 0 */
    i = 0;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 65536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 1 */
    i = 1;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 65536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 3 */
    i = 3;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 2; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 65536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 4 */
    i = 4;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 699984;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 699984);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    Ready_Patterns(tp, pattern_setup, pattern, 5);
    /* start */
    for (i = 0; i < tp->loop_size; i++) {
        Tetra_Pattern * p = NULL;
        int newloc;
                
/* operations */
tp->read_fn(cb, pattern[ 2 ].value + (i * 1), "*zptr: Linear, count 1, step 1");
tp->read_fn(cb, pattern[ 4 ].value + tp->random_fn(tp, 699984), "*block: Random, within 699984, count 1");
tp->read_fn(cb, pattern[ 3 ].value + 0, "huh: Literal");
tp->read_fn(cb, pattern[ 3 ].value + 0, "huh: Literal");
tp->read_fn(cb, pattern[ 0 ].value + 0, "block: Static, count 1");
tp->read_fn(cb, pattern[ 1 ].value + 0, "zptr: Static, count 1");
tp->do_tick_fn(tp, TICK_LOOP_OVERHEAD);

/* generate pattern 0 */
p = &pattern[ 0 ];
newloc = 0;

/* generate pattern 1 */
p = &pattern[ 1 ];
newloc = 0;

/* generate pattern 2 */
p = &pattern[ 2 ];
newloc = tp->tiling_flag && ((i % p->interval) == (p->interval - 1));

        if (newloc) {
            if (p->during) {
                p->value = tp->close_fn(cb, p->value);
            }
            if (p->during) {
                int64_t offset = tp->tiling_flag ? ((int64_t) (i+1) * 1) : 0;
                ulongint space = p->space;
                p->value = tp->open_fn(cb, p->value + offset,
                        p->size, &space, p->read_only) - offset;
            }
        } /* if (newloc) */
/* generate pattern 3 */
p = &pattern[ 3 ];
newloc = 0;

/* generate pattern 4 */
p = &pattern[ 4 ];
newloc = 0;

    } /* for */
   
    for (i = 0; i < 5; i++) {
        if (pattern[i].close) {
            tp->close_fn(cb, pattern[i].value);
        }
    }
} /* function */
/* bzip2,qSort3, 2C 1C 1C 1R[683.6k] 1S+1*/



static void CRC32_31_19_29(Tetra_Params * tp) {
    void * cb = tp->mem_model_cb;

    /* initialisation */
    ulongint i;
    ulongint read_only_remaining = tp->ro_max;
    Tetra_Pattern pattern_setup[ MAX_PATTERNS ];
    Tetra_Pattern pattern[ MAX_PATTERNS ];
    memset (pattern_setup, 0, sizeof(Tetra_Pattern) * MAX_PATTERNS);
    assert ( MAX_PATTERNS >= 3 ) ;
    
    /* initialise pattern 0 */
    i = 0;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 65536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 2 */
    i = 2;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1536;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 1536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 1 */
    i = 1;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 4; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (0 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 65536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    Ready_Patterns(tp, pattern_setup, pattern, 3);
    /* start */
    for (i = 0; i < tp->loop_size; i++) {
        Tetra_Pattern * p = NULL;
        int newloc;
                
/* operations */
tp->read_fn(cb, pattern[ 1 ].value + 0, "charcnt: Local, count 4");
tp->write_fn(cb, pattern[ 1 ].value + 0, "charcnt: Local, count 4");
tp->read_fn(cb, pattern[ 1 ].value + 0, "charcnt: Local, count 4");
tp->read_fn(cb, pattern[ 1 ].value + 0, "charcnt: Local, count 4");
tp->read_fn(cb, pattern[ 2 ].value + tp->random_fn(tp, 1536), "crctable: Random, within 1536, count 1");
tp->read_fn(cb, pattern[ 0 ].value + 0, "fileptr: Local, count 1");
tp->do_tick_fn(tp, TICK_LOOP_OVERHEAD);

/* generate pattern 0 */
p = &pattern[ 0 ];
newloc = 0;

/* generate pattern 1 */
p = &pattern[ 1 ];
newloc = 0;

/* generate pattern 2 */
p = &pattern[ 2 ];
newloc = 0;

    } /* for */
   
    for (i = 0; i < 3; i++) {
        if (pattern[i].close) {
            tp->close_fn(cb, pattern[i].value);
        }
    }
} /* function */
/* CRC32,crc32file, 1C 4C* 1R[1.5k]*/



static void djpeg_331(Tetra_Params * tp) {
    void * cb = tp->mem_model_cb;

    /* initialisation */
    ulongint i;
    ulongint read_only_remaining = tp->ro_max;
    Tetra_Pattern pattern_setup[ MAX_PATTERNS ];
    Tetra_Pattern pattern[ MAX_PATTERNS ];
    memset (pattern_setup, 0, sizeof(Tetra_Pattern) * MAX_PATTERNS);
    assert ( MAX_PATTERNS >= 6 ) ;
    
    /* initialise pattern 0 */
    i = 0;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 3; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 1) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = (loop_size * 1);
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 20000);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
        p->interval = tp->tile_size / 1; /* abs(a.step) */
        if (p->interval == 0) p->interval = 1;
    }
    /* initialise pattern 2 */
    i = 2;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 2; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1020;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 1020);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 3 */
    i = 3;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1020;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 1020);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 4 */
    i = 4;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1020;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 1020);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 5 */
    i = 5;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 3; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1408;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 1408);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 1 */
    i = 1;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 3; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (0 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 1) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = (loop_size * 3);
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 60000);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
        p->interval = tp->tile_size / 3; /* abs(a.step) */
        if (p->interval == 0) p->interval = 1;
    }
    Ready_Patterns(tp, pattern_setup, pattern, 6);
    /* start */
    for (i = 0; i < tp->loop_size; i++) {
        Tetra_Pattern * p = NULL;
        int newloc;
                
/* operations */
tp->read_fn(cb, pattern[ 4 ].value + tp->random_fn(tp, 1020), "colour_tables: Random, within 1020, count 1");
tp->read_fn(cb, pattern[ 3 ].value + tp->random_fn(tp, 1020), "colour_tables: Random, within 1020, count 1");
tp->read_fn(cb, pattern[ 0 ].value + (i * 1), "input_data: Linear, count 3, step 1");
tp->write_fn(cb, pattern[ 1 ].value + (i * 3), "output: Linear, count 3, step 3");
tp->write_fn(cb, pattern[ 1 ].value + (i * 3), "output: Linear, count 3, step 3");
tp->read_fn(cb, pattern[ 5 ].value + tp->random_fn(tp, 1408), "range_limit: Random, within 1408, count 3");
tp->read_fn(cb, pattern[ 5 ].value + tp->random_fn(tp, 1408), "range_limit: Random, within 1408, count 3");
tp->read_fn(cb, pattern[ 0 ].value + (i * 1), "input_data: Linear, count 3, step 1");
tp->read_fn(cb, pattern[ 2 ].value + tp->random_fn(tp, 1020), "colour_tables: Random, within 1020, count 2");
tp->write_fn(cb, pattern[ 1 ].value + (i * 3), "output: Linear, count 3, step 3");
tp->read_fn(cb, pattern[ 0 ].value + (i * 1), "input_data: Linear, count 3, step 1");
tp->read_fn(cb, pattern[ 5 ].value + tp->random_fn(tp, 1408), "range_limit: Random, within 1408, count 3");
tp->read_fn(cb, pattern[ 2 ].value + tp->random_fn(tp, 1020), "colour_tables: Random, within 1020, count 2");
tp->do_tick_fn(tp, TICK_LOOP_OVERHEAD);

/* generate pattern 0 */
p = &pattern[ 0 ];
newloc = tp->tiling_flag && ((i % p->interval) == (p->interval - 1));

        if (newloc) {
            if (p->during) {
                p->value = tp->close_fn(cb, p->value);
            }
            if (p->during) {
                int64_t offset = tp->tiling_flag ? ((int64_t) (i+1) * 1) : 0;
                ulongint space = p->space;
                p->value = tp->open_fn(cb, p->value + offset,
                        p->size, &space, p->read_only) - offset;
            }
        } /* if (newloc) */
/* generate pattern 1 */
p = &pattern[ 1 ];
newloc = tp->tiling_flag && ((i % p->interval) == (p->interval - 1));

        if (newloc) {
            if (p->during) {
                p->value = tp->close_fn(cb, p->value);
            }
            if (p->during) {
                int64_t offset = tp->tiling_flag ? ((int64_t) (i+1) * 3) : 0;
                ulongint space = p->space;
                p->value = tp->open_fn(cb, p->value + offset,
                        p->size, &space, p->read_only) - offset;
            }
        } /* if (newloc) */
/* generate pattern 2 */
p = &pattern[ 2 ];
newloc = 0;

/* generate pattern 3 */
p = &pattern[ 3 ];
newloc = 0;

/* generate pattern 4 */
p = &pattern[ 4 ];
newloc = 0;

/* generate pattern 5 */
p = &pattern[ 5 ];
newloc = 0;

    } /* for */
   
    for (i = 0; i < 6; i++) {
        if (pattern[i].close) {
            tp->close_fn(cb, pattern[i].value);
        }
    }
} /* function */
/* djpeg,ycc_rgb_convert, 2R[1020] 1R[1020] 1R[1020] 3R[1.4k] 3S+1 3S+3**/



static void djpeg_344(Tetra_Params * tp) {
    void * cb = tp->mem_model_cb;

    /* initialisation */
    ulongint i;
    ulongint read_only_remaining = tp->ro_max;
    Tetra_Pattern pattern_setup[ MAX_PATTERNS ];
    Tetra_Pattern pattern[ MAX_PATTERNS ];
    memset (pattern_setup, 0, sizeof(Tetra_Pattern) * MAX_PATTERNS);
    assert ( MAX_PATTERNS >= 2 ) ;
    
    /* initialise pattern 0 */
    i = 0;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 2; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 1) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = (loop_size * 1);
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 20000);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
        p->interval = tp->tile_size / 1; /* abs(a.step) */
        if (p->interval == 0) p->interval = 1;
    }
    /* initialise pattern 1 */
    i = 1;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 2; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (0 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 1) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = (loop_size * 2);
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 40000);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
        p->interval = tp->tile_size / 2; /* abs(a.step) */
        if (p->interval == 0) p->interval = 1;
    }
    Ready_Patterns(tp, pattern_setup, pattern, 2);
    /* start */
    for (i = 0; i < tp->loop_size; i++) {
        Tetra_Pattern * p = NULL;
        int newloc;
                
/* operations */
tp->write_fn(cb, pattern[ 1 ].value + (i * 2), "outptr: Linear, count 2, step 2");
tp->write_fn(cb, pattern[ 1 ].value + (i * 2), "outptr: Linear, count 2, step 2");
tp->read_fn(cb, pattern[ 0 ].value + (i * 1), "inptrX: Linear, count 2, step 1");
tp->read_fn(cb, pattern[ 0 ].value + (i * 1), "inptrX: Linear, count 2, step 1");
tp->do_tick_fn(tp, TICK_LOOP_OVERHEAD);

/* generate pattern 0 */
p = &pattern[ 0 ];
newloc = tp->tiling_flag && ((i % p->interval) == (p->interval - 1));

        if (newloc) {
            if (p->during) {
                p->value = tp->close_fn(cb, p->value);
            }
            if (p->during) {
                int64_t offset = tp->tiling_flag ? ((int64_t) (i+1) * 1) : 0;
                ulongint space = p->space;
                p->value = tp->open_fn(cb, p->value + offset,
                        p->size, &space, p->read_only) - offset;
            }
        } /* if (newloc) */
/* generate pattern 1 */
p = &pattern[ 1 ];
newloc = tp->tiling_flag && ((i % p->interval) == (p->interval - 1));

        if (newloc) {
            if (p->during) {
                p->value = tp->close_fn(cb, p->value);
            }
            if (p->during) {
                int64_t offset = tp->tiling_flag ? ((int64_t) (i+1) * 2) : 0;
                ulongint space = p->space;
                p->value = tp->open_fn(cb, p->value + offset,
                        p->size, &space, p->read_only) - offset;
            }
        } /* if (newloc) */
    } /* for */
   
    for (i = 0; i < 2; i++) {
        if (pattern[i].close) {
            tp->close_fn(cb, pattern[i].value);
        }
    }
} /* function */
/* djpeg,h2v2_fancy_upsample, 2S+1 2S+2**/



static void djpeg_501(Tetra_Params * tp) {
    void * cb = tp->mem_model_cb;

    /* initialisation */
    ulongint i;
    ulongint read_only_remaining = tp->ro_max;
    Tetra_Pattern pattern_setup[ MAX_PATTERNS ];
    Tetra_Pattern pattern[ MAX_PATTERNS ];
    memset (pattern_setup, 0, sizeof(Tetra_Pattern) * MAX_PATTERNS);
    assert ( MAX_PATTERNS >= 2 ) ;
    
    /* initialise pattern 1 */
    i = 1;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 9; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1408;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 1408);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 0 */
    i = 0;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 16; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (0 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 65536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    Ready_Patterns(tp, pattern_setup, pattern, 2);
    /* start */
    for (i = 0; i < tp->loop_size; i++) {
        Tetra_Pattern * p = NULL;
        int newloc;
                
/* operations */
tp->write_fn(cb, pattern[ 0 ].value + 0, "outptr: Local, count 16");
tp->read_fn(cb, pattern[ 1 ].value + tp->random_fn(tp, 1408), "range_limit: Random, within 1408, count 9");
tp->write_fn(cb, pattern[ 0 ].value + 0, "outptr: Local, count 16");
tp->read_fn(cb, pattern[ 1 ].value + tp->random_fn(tp, 1408), "range_limit: Random, within 1408, count 9");
tp->write_fn(cb, pattern[ 0 ].value + 0, "outptr: Local, count 16");
tp->read_fn(cb, pattern[ 1 ].value + tp->random_fn(tp, 1408), "range_limit: Random, within 1408, count 9");
tp->read_fn(cb, pattern[ 1 ].value + tp->random_fn(tp, 1408), "range_limit: Random, within 1408, count 9");
tp->write_fn(cb, pattern[ 0 ].value + 0, "outptr: Local, count 16");
tp->read_fn(cb, pattern[ 1 ].value + tp->random_fn(tp, 1408), "range_limit: Random, within 1408, count 9");
tp->read_fn(cb, pattern[ 1 ].value + tp->random_fn(tp, 1408), "range_limit: Random, within 1408, count 9");
tp->write_fn(cb, pattern[ 0 ].value + 0, "outptr: Local, count 16");
tp->write_fn(cb, pattern[ 0 ].value + 0, "outptr: Local, count 16");
tp->write_fn(cb, pattern[ 0 ].value + 0, "outptr: Local, count 16");
tp->write_fn(cb, pattern[ 0 ].value + 0, "outptr: Local, count 16");
tp->write_fn(cb, pattern[ 0 ].value + 0, "outptr: Local, count 16");
tp->write_fn(cb, pattern[ 0 ].value + 0, "outptr: Local, count 16");
tp->write_fn(cb, pattern[ 0 ].value + 0, "outptr: Local, count 16");
tp->write_fn(cb, pattern[ 0 ].value + 0, "outptr: Local, count 16");
tp->read_fn(cb, pattern[ 1 ].value + tp->random_fn(tp, 1408), "range_limit: Random, within 1408, count 9");
tp->write_fn(cb, pattern[ 0 ].value + 0, "outptr: Local, count 16");
tp->write_fn(cb, pattern[ 0 ].value + 0, "outptr: Local, count 16");
tp->read_fn(cb, pattern[ 1 ].value + tp->random_fn(tp, 1408), "range_limit: Random, within 1408, count 9");
tp->write_fn(cb, pattern[ 0 ].value + 0, "outptr: Local, count 16");
tp->read_fn(cb, pattern[ 1 ].value + tp->random_fn(tp, 1408), "range_limit: Random, within 1408, count 9");
tp->write_fn(cb, pattern[ 0 ].value + 0, "outptr: Local, count 16");
tp->do_tick_fn(tp, TICK_LOOP_OVERHEAD);

/* generate pattern 0 */
p = &pattern[ 0 ];
newloc = 0;

/* generate pattern 1 */
p = &pattern[ 1 ];
newloc = 0;

    } /* for */
   
    for (i = 0; i < 2; i++) {
        if (pattern[i].close) {
            tp->close_fn(cb, pattern[i].value);
        }
    }
} /* function */
/* djpeg,jpeg_idct_islow, 16C* 9R[1.4k]*/



static void djpeg_496(Tetra_Params * tp) {
    void * cb = tp->mem_model_cb;

    /* initialisation */
    ulongint i;
    ulongint read_only_remaining = tp->ro_max;
    Tetra_Pattern pattern_setup[ MAX_PATTERNS ];
    Tetra_Pattern pattern[ MAX_PATTERNS ];
    memset (pattern_setup, 0, sizeof(Tetra_Pattern) * MAX_PATTERNS);
    assert ( MAX_PATTERNS >= 2 ) ;
    
    /* initialise pattern 0 */
    i = 0;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 16; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 134;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 134);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 1 */
    i = 1;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 9; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 160;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 160);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    Ready_Patterns(tp, pattern_setup, pattern, 2);
    /* start */
    for (i = 0; i < tp->loop_size; i++) {
        Tetra_Pattern * p = NULL;
        int newloc;
                
/* operations */
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 134), "inptr: Random, within 134, count 16");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 134), "inptr: Random, within 134, count 16");
tp->read_fn(cb, pattern[ 1 ].value + tp->random_fn(tp, 160), "quantptr: Random, within 160, count 9");
tp->read_fn(cb, pattern[ 1 ].value + tp->random_fn(tp, 160), "quantptr: Random, within 160, count 9");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 134), "inptr: Random, within 134, count 16");
tp->read_fn(cb, pattern[ 1 ].value + tp->random_fn(tp, 160), "quantptr: Random, within 160, count 9");
tp->read_fn(cb, pattern[ 1 ].value + tp->random_fn(tp, 160), "quantptr: Random, within 160, count 9");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 134), "inptr: Random, within 134, count 16");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 134), "inptr: Random, within 134, count 16");
tp->read_fn(cb, pattern[ 1 ].value + tp->random_fn(tp, 160), "quantptr: Random, within 160, count 9");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 134), "inptr: Random, within 134, count 16");
tp->read_fn(cb, pattern[ 1 ].value + tp->random_fn(tp, 160), "quantptr: Random, within 160, count 9");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 134), "inptr: Random, within 134, count 16");
tp->read_fn(cb, pattern[ 1 ].value + tp->random_fn(tp, 160), "quantptr: Random, within 160, count 9");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 134), "inptr: Random, within 134, count 16");
tp->read_fn(cb, pattern[ 1 ].value + tp->random_fn(tp, 160), "quantptr: Random, within 160, count 9");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 134), "inptr: Random, within 134, count 16");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 134), "inptr: Random, within 134, count 16");
tp->read_fn(cb, pattern[ 1 ].value + tp->random_fn(tp, 160), "quantptr: Random, within 160, count 9");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 134), "inptr: Random, within 134, count 16");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 134), "inptr: Random, within 134, count 16");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 134), "inptr: Random, within 134, count 16");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 134), "inptr: Random, within 134, count 16");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 134), "inptr: Random, within 134, count 16");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 134), "inptr: Random, within 134, count 16");
tp->do_tick_fn(tp, TICK_LOOP_OVERHEAD);

/* generate pattern 0 */
p = &pattern[ 0 ];
newloc = 0;

/* generate pattern 1 */
p = &pattern[ 1 ];
newloc = 0;

    } /* for */
   
    for (i = 0; i < 2; i++) {
        if (pattern[i].close) {
            tp->close_fn(cb, pattern[i].value);
        }
    }
} /* function */
/* djpeg,jpeg_idct_islow, 16R[134] 9R[160]*/



static void fft_234(Tetra_Params * tp) {
    void * cb = tp->mem_model_cb;

    /* initialisation */
    ulongint i;
    ulongint read_only_remaining = tp->ro_max;
    Tetra_Pattern pattern_setup[ MAX_PATTERNS ];
    Tetra_Pattern pattern[ MAX_PATTERNS ];
    memset (pattern_setup, 0, sizeof(Tetra_Pattern) * MAX_PATTERNS);
    assert ( MAX_PATTERNS >= 4 ) ;
    
    /* initialise pattern 1 */
    i = 1;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 2; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 1) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = (loop_size * 8);
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 160000);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
        p->interval = tp->tile_size / 8; /* abs(a.step) */
        if (p->interval == 0) p->interval = 1;
    }
    /* initialise pattern 0 */
    i = 0;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 4; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (0 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 1) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = (loop_size * 8);
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 160000);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
        p->interval = tp->tile_size / 8; /* abs(a.step) */
        if (p->interval == 0) p->interval = 1;
    }
    /* initialise pattern 2 */
    i = 2;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 3; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (0 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 1) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = (loop_size * 8);
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 160000);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
        p->interval = tp->tile_size / 8; /* abs(a.step) */
        if (p->interval == 0) p->interval = 1;
    }
    /* initialise pattern 3 */
    i = 3;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 3; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (0 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 1) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = (loop_size * 8);
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 160000);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
        p->interval = tp->tile_size / 8; /* abs(a.step) */
        if (p->interval == 0) p->interval = 1;
    }
    Ready_Patterns(tp, pattern_setup, pattern, 4);
    /* start */
    for (i = 0; i < tp->loop_size; i++) {
        Tetra_Pattern * p = NULL;
        int newloc;
                
/* operations */
tp->write_fn(cb, pattern[ 2 ].value + (i * 8), "RealOut[j]: Linear, count 3, step 8");
tp->read_fn(cb, pattern[ 2 ].value + (i * 8), "RealOut[j]: Linear, count 3, step 8");
tp->write_fn(cb, pattern[ 0 ].value + (i * 8), "RealOut[k]: Linear, count 4, step 8");
tp->read_fn(cb, pattern[ 1 ].value + (i * 8), "ImagOut[k]: Linear, count 2, step 8");
tp->read_fn(cb, pattern[ 3 ].value + (i * 8), "ImagOut[j]: Linear, count 3, step 8");
tp->read_fn(cb, pattern[ 0 ].value + (i * 8), "RealOut[k]: Linear, count 4, step 8");
tp->read_fn(cb, pattern[ 3 ].value + (i * 8), "ImagOut[j]: Linear, count 3, step 8");
tp->write_fn(cb, pattern[ 0 ].value + (i * 8), "RealOut[k]: Linear, count 4, step 8");
tp->write_fn(cb, pattern[ 3 ].value + (i * 8), "ImagOut[j]: Linear, count 3, step 8");
tp->read_fn(cb, pattern[ 1 ].value + (i * 8), "ImagOut[k]: Linear, count 2, step 8");
tp->read_fn(cb, pattern[ 0 ].value + (i * 8), "RealOut[k]: Linear, count 4, step 8");
tp->read_fn(cb, pattern[ 2 ].value + (i * 8), "RealOut[j]: Linear, count 3, step 8");
tp->do_tick_fn(tp, TICK_LOOP_OVERHEAD);

/* generate pattern 0 */
p = &pattern[ 0 ];
newloc = tp->tiling_flag && ((i % p->interval) == (p->interval - 1));

        if (newloc) {
            if (p->during) {
                p->value = tp->close_fn(cb, p->value);
            }
            if (p->during) {
                int64_t offset = tp->tiling_flag ? ((int64_t) (i+1) * 8) : 0;
                ulongint space = p->space;
                p->value = tp->open_fn(cb, p->value + offset,
                        p->size, &space, p->read_only) - offset;
            }
        } /* if (newloc) */
/* generate pattern 1 */
p = &pattern[ 1 ];
newloc = tp->tiling_flag && ((i % p->interval) == (p->interval - 1));

        if (newloc) {
            if (p->during) {
                p->value = tp->close_fn(cb, p->value);
            }
            if (p->during) {
                int64_t offset = tp->tiling_flag ? ((int64_t) (i+1) * 8) : 0;
                ulongint space = p->space;
                p->value = tp->open_fn(cb, p->value + offset,
                        p->size, &space, p->read_only) - offset;
            }
        } /* if (newloc) */
/* generate pattern 2 */
p = &pattern[ 2 ];
newloc = tp->tiling_flag && ((i % p->interval) == (p->interval - 1));

        if (newloc) {
            if (p->during) {
                p->value = tp->close_fn(cb, p->value);
            }
            if (p->during) {
                int64_t offset = tp->tiling_flag ? ((int64_t) (i+1) * 8) : 0;
                ulongint space = p->space;
                p->value = tp->open_fn(cb, p->value + offset,
                        p->size, &space, p->read_only) - offset;
            }
        } /* if (newloc) */
/* generate pattern 3 */
p = &pattern[ 3 ];
newloc = tp->tiling_flag && ((i % p->interval) == (p->interval - 1));

        if (newloc) {
            if (p->during) {
                p->value = tp->close_fn(cb, p->value);
            }
            if (p->during) {
                int64_t offset = tp->tiling_flag ? ((int64_t) (i+1) * 8) : 0;
                ulongint space = p->space;
                p->value = tp->open_fn(cb, p->value + offset,
                        p->size, &space, p->read_only) - offset;
            }
        } /* if (newloc) */
    } /* for */
   
    for (i = 0; i < 4; i++) {
        if (pattern[i].close) {
            tp->close_fn(cb, pattern[i].value);
        }
    }
} /* function */
/* fft,fft_float, 4S+8* 2S+8 3S+8* 3S+8**/



static void gap_1197(Tetra_Params * tp) {
    void * cb = tp->mem_model_cb;

    /* initialisation */
    ulongint i;
    ulongint read_only_remaining = tp->ro_max;
    Tetra_Pattern pattern_setup[ MAX_PATTERNS ];
    Tetra_Pattern pattern[ MAX_PATTERNS ];
    memset (pattern_setup, 0, sizeof(Tetra_Pattern) * MAX_PATTERNS);
    assert ( MAX_PATTERNS >= 2 ) ;
    
    /* initialise pattern 0 */
    i = 0;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 4; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 1) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = (loop_size * 2);
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 40000);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
        p->interval = tp->tile_size / 2; /* abs(a.step) */
        if (p->interval == 0) p->interval = 1;
    }
    /* initialise pattern 1 */
    i = 1;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 8; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (0 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 1) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = (loop_size * 2);
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 40000);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
        p->interval = tp->tile_size / 2; /* abs(a.step) */
        if (p->interval == 0) p->interval = 1;
    }
    Ready_Patterns(tp, pattern_setup, pattern, 2);
    /* start */
    for (i = 0; i < tp->loop_size; i++) {
        Tetra_Pattern * p = NULL;
        int newloc;
                
/* operations */
tp->write_fn(cb, pattern[ 1 ].value + (i * 2), "r[]: Linear, count 8, step 2");
tp->read_fn(cb, pattern[ 1 ].value + (i * 2), "r[]: Linear, count 8, step 2");
tp->read_fn(cb, pattern[ 0 ].value + (i * 2), "r[]: Linear, count 4, step 2");
tp->read_fn(cb, pattern[ 0 ].value + (i * 2), "r[]: Linear, count 4, step 2");
tp->read_fn(cb, pattern[ 1 ].value + (i * 2), "r[]: Linear, count 8, step 2");
tp->write_fn(cb, pattern[ 1 ].value + (i * 2), "r[]: Linear, count 8, step 2");
tp->read_fn(cb, pattern[ 1 ].value + (i * 2), "r[]: Linear, count 8, step 2");
tp->read_fn(cb, pattern[ 0 ].value + (i * 2), "r[]: Linear, count 4, step 2");
tp->write_fn(cb, pattern[ 1 ].value + (i * 2), "r[]: Linear, count 8, step 2");
tp->write_fn(cb, pattern[ 1 ].value + (i * 2), "r[]: Linear, count 8, step 2");
tp->read_fn(cb, pattern[ 1 ].value + (i * 2), "r[]: Linear, count 8, step 2");
tp->read_fn(cb, pattern[ 0 ].value + (i * 2), "r[]: Linear, count 4, step 2");
tp->do_tick_fn(tp, TICK_LOOP_OVERHEAD);

/* generate pattern 0 */
p = &pattern[ 0 ];
newloc = tp->tiling_flag && ((i % p->interval) == (p->interval - 1));

        if (newloc) {
            if (p->during) {
                p->value = tp->close_fn(cb, p->value);
            }
            if (p->during) {
                int64_t offset = tp->tiling_flag ? ((int64_t) (i+1) * 2) : 0;
                ulongint space = p->space;
                p->value = tp->open_fn(cb, p->value + offset,
                        p->size, &space, p->read_only) - offset;
            }
        } /* if (newloc) */
/* generate pattern 1 */
p = &pattern[ 1 ];
newloc = tp->tiling_flag && ((i % p->interval) == (p->interval - 1));

        if (newloc) {
            if (p->during) {
                p->value = tp->close_fn(cb, p->value);
            }
            if (p->during) {
                int64_t offset = tp->tiling_flag ? ((int64_t) (i+1) * 2) : 0;
                ulongint space = p->space;
                p->value = tp->open_fn(cb, p->value + offset,
                        p->size, &space, p->read_only) - offset;
            }
        } /* if (newloc) */
    } /* for */
   
    for (i = 0; i < 2; i++) {
        if (pattern[i].close) {
            tp->close_fn(cb, pattern[i].value);
        }
    }
} /* function */
/* gap,ProdInt, 4S+2 8S+2**/



static void gsm_332(Tetra_Params * tp) {
    void * cb = tp->mem_model_cb;

    /* initialisation */
    ulongint i;
    ulongint read_only_remaining = tp->ro_max;
    Tetra_Pattern pattern_setup[ MAX_PATTERNS ];
    Tetra_Pattern pattern[ MAX_PATTERNS ];
    memset (pattern_setup, 0, sizeof(Tetra_Pattern) * MAX_PATTERNS);
    assert ( MAX_PATTERNS >= 1 ) ;
    
    /* initialise pattern 0 */
    i = 0;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 40; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 4120;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 4120);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    Ready_Patterns(tp, pattern_setup, pattern, 1);
    /* start */
    for (i = 0; i < tp->loop_size; i++) {
        Tetra_Pattern * p = NULL;
        int newloc;
                
/* operations */
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4120), "dp: Random, within 4120, count 40");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4120), "dp: Random, within 4120, count 40");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4120), "dp: Random, within 4120, count 40");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4120), "dp: Random, within 4120, count 40");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4120), "dp: Random, within 4120, count 40");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4120), "dp: Random, within 4120, count 40");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4120), "dp: Random, within 4120, count 40");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4120), "dp: Random, within 4120, count 40");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4120), "dp: Random, within 4120, count 40");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4120), "dp: Random, within 4120, count 40");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4120), "dp: Random, within 4120, count 40");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4120), "dp: Random, within 4120, count 40");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4120), "dp: Random, within 4120, count 40");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4120), "dp: Random, within 4120, count 40");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4120), "dp: Random, within 4120, count 40");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4120), "dp: Random, within 4120, count 40");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4120), "dp: Random, within 4120, count 40");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4120), "dp: Random, within 4120, count 40");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4120), "dp: Random, within 4120, count 40");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4120), "dp: Random, within 4120, count 40");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4120), "dp: Random, within 4120, count 40");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4120), "dp: Random, within 4120, count 40");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4120), "dp: Random, within 4120, count 40");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4120), "dp: Random, within 4120, count 40");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4120), "dp: Random, within 4120, count 40");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4120), "dp: Random, within 4120, count 40");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4120), "dp: Random, within 4120, count 40");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4120), "dp: Random, within 4120, count 40");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4120), "dp: Random, within 4120, count 40");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4120), "dp: Random, within 4120, count 40");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4120), "dp: Random, within 4120, count 40");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4120), "dp: Random, within 4120, count 40");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4120), "dp: Random, within 4120, count 40");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4120), "dp: Random, within 4120, count 40");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4120), "dp: Random, within 4120, count 40");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4120), "dp: Random, within 4120, count 40");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4120), "dp: Random, within 4120, count 40");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4120), "dp: Random, within 4120, count 40");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4120), "dp: Random, within 4120, count 40");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4120), "dp: Random, within 4120, count 40");
tp->do_tick_fn(tp, TICK_LOOP_OVERHEAD);

/* generate pattern 0 */
p = &pattern[ 0 ];
newloc = 0;

    } /* for */
   
    for (i = 0; i < 1; i++) {
        if (pattern[i].close) {
            tp->close_fn(cb, pattern[i].value);
        }
    }
} /* function */
/* gsm,Calculation_of_the_LTP_parameters, 40R[4.0k]*/



static void gsm_115(Tetra_Params * tp) {
    void * cb = tp->mem_model_cb;

    /* initialisation */
    ulongint i;
    ulongint read_only_remaining = tp->ro_max;
    Tetra_Pattern pattern_setup[ MAX_PATTERNS ];
    Tetra_Pattern pattern[ MAX_PATTERNS ];
    memset (pattern_setup, 0, sizeof(Tetra_Pattern) * MAX_PATTERNS);
    assert ( MAX_PATTERNS >= 1 ) ;
    
    /* initialise pattern 0 */
    i = 0;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 2; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (0 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 1) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = (loop_size * 2);
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 40000);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
        p->interval = tp->tile_size / 2; /* abs(a.step) */
        if (p->interval == 0) p->interval = 1;
    }
    Ready_Patterns(tp, pattern_setup, pattern, 1);
    /* start */
    for (i = 0; i < tp->loop_size; i++) {
        Tetra_Pattern * p = NULL;
        int newloc;
                
/* operations */
tp->read_fn(cb, pattern[ 0 ].value + (i * 2), "u[i]: Linear, count 2, step 2");
tp->write_fn(cb, pattern[ 0 ].value + (i * 2), "u[i]: Linear, count 2, step 2");
tp->do_tick_fn(tp, TICK_LOOP_OVERHEAD);

/* generate pattern 0 */
p = &pattern[ 0 ];
newloc = tp->tiling_flag && ((i % p->interval) == (p->interval - 1));

        if (newloc) {
            if (p->during) {
                p->value = tp->close_fn(cb, p->value);
            }
            if (p->during) {
                int64_t offset = tp->tiling_flag ? ((int64_t) (i+1) * 2) : 0;
                ulongint space = p->space;
                p->value = tp->open_fn(cb, p->value + offset,
                        p->size, &space, p->read_only) - offset;
            }
        } /* if (newloc) */
    } /* for */
   
    for (i = 0; i < 1; i++) {
        if (pattern[i].close) {
            tp->close_fn(cb, pattern[i].value);
        }
    }
} /* function */
/* gsm,Short_term_analysis_filtering, 2S+2**/



static void gsm_297(Tetra_Params * tp) {
    void * cb = tp->mem_model_cb;

    /* initialisation */
    ulongint i;
    ulongint read_only_remaining = tp->ro_max;
    Tetra_Pattern pattern_setup[ MAX_PATTERNS ];
    Tetra_Pattern pattern[ MAX_PATTERNS ];
    memset (pattern_setup, 0, sizeof(Tetra_Pattern) * MAX_PATTERNS);
    assert ( MAX_PATTERNS >= 1 ) ;
    
    /* initialise pattern 0 */
    i = 0;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 9; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 1) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = (loop_size * 2);
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 40000);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
        p->interval = tp->tile_size / 2; /* abs(a.step) */
        if (p->interval == 0) p->interval = 1;
    }
    Ready_Patterns(tp, pattern_setup, pattern, 1);
    /* start */
    for (i = 0; i < tp->loop_size; i++) {
        Tetra_Pattern * p = NULL;
        int newloc;
                
/* operations */
tp->read_fn(cb, pattern[ 0 ].value + (i * 2), "e: Linear, count 9, step 2");
tp->read_fn(cb, pattern[ 0 ].value + (i * 2), "e: Linear, count 9, step 2");
tp->read_fn(cb, pattern[ 0 ].value + (i * 2), "e: Linear, count 9, step 2");
tp->read_fn(cb, pattern[ 0 ].value + (i * 2), "e: Linear, count 9, step 2");
tp->read_fn(cb, pattern[ 0 ].value + (i * 2), "e: Linear, count 9, step 2");
tp->read_fn(cb, pattern[ 0 ].value + (i * 2), "e: Linear, count 9, step 2");
tp->read_fn(cb, pattern[ 0 ].value + (i * 2), "e: Linear, count 9, step 2");
tp->read_fn(cb, pattern[ 0 ].value + (i * 2), "e: Linear, count 9, step 2");
tp->read_fn(cb, pattern[ 0 ].value + (i * 2), "e: Linear, count 9, step 2");
tp->do_tick_fn(tp, TICK_LOOP_OVERHEAD);

/* generate pattern 0 */
p = &pattern[ 0 ];
newloc = tp->tiling_flag && ((i % p->interval) == (p->interval - 1));

        if (newloc) {
            if (p->during) {
                p->value = tp->close_fn(cb, p->value);
            }
            if (p->during) {
                int64_t offset = tp->tiling_flag ? ((int64_t) (i+1) * 2) : 0;
                ulongint space = p->space;
                p->value = tp->open_fn(cb, p->value + offset,
                        p->size, &space, p->read_only) - offset;
            }
        } /* if (newloc) */
    } /* for */
   
    for (i = 0; i < 1; i++) {
        if (pattern[i].close) {
            tp->close_fn(cb, pattern[i].value);
        }
    }
} /* function */
/* gsm,Weighting_filter, 9S+2*/



static void gsm_376_379(Tetra_Params * tp) {
    void * cb = tp->mem_model_cb;

    /* initialisation */
    ulongint i;
    ulongint read_only_remaining = tp->ro_max;
    Tetra_Pattern pattern_setup[ MAX_PATTERNS ];
    Tetra_Pattern pattern[ MAX_PATTERNS ];
    memset (pattern_setup, 0, sizeof(Tetra_Pattern) * MAX_PATTERNS);
    assert ( MAX_PATTERNS >= 3 ) ;
    
    /* initialise pattern 0 */
    i = 0;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 65536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 2 */
    i = 2;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 65536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 1 */
    i = 1;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 4; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (0 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 65536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    Ready_Patterns(tp, pattern_setup, pattern, 3);
    /* start */
    for (i = 0; i < tp->loop_size; i++) {
        Tetra_Pattern * p = NULL;
        int newloc;
                
/* operations */
tp->read_fn(cb, pattern[ 1 ].value + 0, "in: Local, count 4");
tp->read_fn(cb, pattern[ 1 ].value + 0, "in: Local, count 4");
tp->write_fn(cb, pattern[ 1 ].value + 0, "in: Local, count 4");
tp->read_fn(cb, pattern[ 2 ].value + 0, "fgetc(in): Local, count 1");
tp->read_fn(cb, pattern[ 0 ].value + 0, "in: Static, count 1");
tp->read_fn(cb, pattern[ 1 ].value + 0, "in: Local, count 4");
tp->do_tick_fn(tp, TICK_LOOP_OVERHEAD);

/* generate pattern 0 */
p = &pattern[ 0 ];
newloc = 0;

/* generate pattern 1 */
p = &pattern[ 1 ];
newloc = 0;

/* generate pattern 2 */
p = &pattern[ 2 ];
newloc = 0;

    } /* for */
   
    for (i = 0; i < 3; i++) {
        if (pattern[i].close) {
            tp->close_fn(cb, pattern[i].value);
        }
    }
} /* function */
/* gsm,ulaw_input, 4C* 1C 1C*/



static void ispell_90(Tetra_Params * tp) {
    void * cb = tp->mem_model_cb;

    /* initialisation */
    ulongint i;
    ulongint read_only_remaining = tp->ro_max;
    Tetra_Pattern pattern_setup[ MAX_PATTERNS ];
    Tetra_Pattern pattern[ MAX_PATTERNS ];
    memset (pattern_setup, 0, sizeof(Tetra_Pattern) * MAX_PATTERNS);
    assert ( MAX_PATTERNS >= 3 ) ;
    
    /* initialise pattern 0 */
    i = 0;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 2; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 65536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 1 */
    i = 1;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 65536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 2 */
    i = 2;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 6; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (0 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 1) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = (loop_size * 24);
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 480000);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
        p->interval = tp->tile_size / 24; /* abs(a.step) */
        if (p->interval == 0) p->interval = 1;
    }
    Ready_Patterns(tp, pattern_setup, pattern, 3);
    /* start */
    for (i = 0; i < tp->loop_size; i++) {
        Tetra_Pattern * p = NULL;
        int newloc;
                
/* operations */
tp->read_fn(cb, pattern[ 2 ].value + ((i * 24) + 18), "dp: Struct, count 6, step 24");
tp->read_fn(cb, pattern[ 0 ].value + 0, "hashstrings: Static, count 2");
tp->read_fn(cb, pattern[ 0 ].value + 0, "hashstrings: Static, count 2");
tp->read_fn(cb, pattern[ 1 ].value + 0, "hashtbl: Static, count 1");
tp->read_fn(cb, pattern[ 2 ].value + ((i * 24) + 16), "dp: Struct, count 6, step 24");
tp->read_fn(cb, pattern[ 2 ].value + ((i * 24) + 6), "dp: Struct, count 6, step 24");
tp->write_fn(cb, pattern[ 2 ].value + ((i * 24) + 6), "dp: Struct, count 6, step 24");
tp->write_fn(cb, pattern[ 2 ].value + ((i * 24) + 14), "dp: Struct, count 6, step 24");
tp->read_fn(cb, pattern[ 2 ].value + ((i * 24) + 19), "dp: Struct, count 6, step 24");
tp->do_tick_fn(tp, TICK_LOOP_OVERHEAD);

/* generate pattern 0 */
p = &pattern[ 0 ];
newloc = 0;

/* generate pattern 1 */
p = &pattern[ 1 ];
newloc = 0;

/* generate pattern 2 */
p = &pattern[ 2 ];
newloc = tp->tiling_flag && ((i % p->interval) == (p->interval - 1));

        if (newloc) {
            if (p->during) {
                p->value = tp->close_fn(cb, p->value);
            }
            if (p->during) {
                int64_t offset = tp->tiling_flag ? ((int64_t) (i+1) * 24) : 0;
                ulongint space = p->space;
                p->value = tp->open_fn(cb, p->value + offset,
                        p->size, &space, p->read_only) - offset;
            }
        } /* if (newloc) */
    } /* for */
   
    for (i = 0; i < 3; i++) {
        if (pattern[i].close) {
            tp->close_fn(cb, pattern[i].value);
        }
    }
} /* function */
/* ispell,linit, 2C 1C 6S+24**/



static void ispell_198(Tetra_Params * tp) {
    void * cb = tp->mem_model_cb;

    /* initialisation */
    ulongint i;
    ulongint read_only_remaining = tp->ro_max;
    Tetra_Pattern pattern_setup[ MAX_PATTERNS ];
    Tetra_Pattern pattern[ MAX_PATTERNS ];
    memset (pattern_setup, 0, sizeof(Tetra_Pattern) * MAX_PATTERNS);
    assert ( MAX_PATTERNS >= 3 ) ;
    
    /* initialise pattern 0 */
    i = 0;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 1) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = (loop_size * 1);
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 20000);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
        p->interval = tp->tile_size / 1; /* abs(a.step) */
        if (p->interval == 0) p->interval = 1;
    }
    /* initialise pattern 1 */
    i = 1;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 1) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = (loop_size * 1);
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 20000);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
        p->interval = tp->tile_size / 1; /* abs(a.step) */
        if (p->interval == 0) p->interval = 1;
    }
    /* initialise pattern 2 */
    i = 2;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 88;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 88);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    Ready_Patterns(tp, pattern_setup, pattern, 3);
    /* start */
    for (i = 0; i < tp->loop_size; i++) {
        Tetra_Pattern * p = NULL;
        int newloc;
                
/* operations */
tp->read_fn(cb, pattern[ 2 ].value + tp->random_fn(tp, 88), "caseconversiontable: Random, within 88, count 1");
tp->read_fn(cb, pattern[ 0 ].value + (i * 1), "p: Linear, count 1, step 1");
tp->read_fn(cb, pattern[ 1 ].value + (i * 1), "q: Linear, count 1, step 1");
tp->do_tick_fn(tp, TICK_LOOP_OVERHEAD);

/* generate pattern 0 */
p = &pattern[ 0 ];
newloc = tp->tiling_flag && ((i % p->interval) == (p->interval - 1));

        if (newloc) {
            if (p->during) {
                p->value = tp->close_fn(cb, p->value);
            }
            if (p->during) {
                int64_t offset = tp->tiling_flag ? ((int64_t) (i+1) * 1) : 0;
                ulongint space = p->space;
                p->value = tp->open_fn(cb, p->value + offset,
                        p->size, &space, p->read_only) - offset;
            }
        } /* if (newloc) */
/* generate pattern 1 */
p = &pattern[ 1 ];
newloc = tp->tiling_flag && ((i % p->interval) == (p->interval - 1));

        if (newloc) {
            if (p->during) {
                p->value = tp->close_fn(cb, p->value);
            }
            if (p->during) {
                int64_t offset = tp->tiling_flag ? ((int64_t) (i+1) * 1) : 0;
                ulongint space = p->space;
                p->value = tp->open_fn(cb, p->value + offset,
                        p->size, &space, p->read_only) - offset;
            }
        } /* if (newloc) */
/* generate pattern 2 */
p = &pattern[ 2 ];
newloc = 0;

    } /* for */
   
    for (i = 0; i < 3; i++) {
        if (pattern[i].close) {
            tp->close_fn(cb, pattern[i].value);
        }
    }
} /* function */
/* ispell,good, 1R[88] 1S+1 1S+1*/



static void ispell_156(Tetra_Params * tp) {
    void * cb = tp->mem_model_cb;

    /* initialisation */
    ulongint i;
    ulongint read_only_remaining = tp->ro_max;
    Tetra_Pattern pattern_setup[ MAX_PATTERNS ];
    Tetra_Pattern pattern[ MAX_PATTERNS ];
    memset (pattern_setup, 0, sizeof(Tetra_Pattern) * MAX_PATTERNS);
    assert ( MAX_PATTERNS >= 1 ) ;
    
    /* initialise pattern 0 */
    i = 0;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 2; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (0 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 21040;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 21040);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    Ready_Patterns(tp, pattern_setup, pattern, 1);
    /* start */
    for (i = 0; i < tp->loop_size; i++) {
        Tetra_Pattern * p = NULL;
        int newloc;
                
/* operations */
tp->write_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 21040), "out: Random, within 21040, count 2");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 21040), "out: Random, within 21040, count 2");
tp->do_tick_fn(tp, TICK_LOOP_OVERHEAD);

/* generate pattern 0 */
p = &pattern[ 0 ];
newloc = 0;

    } /* for */
   
    for (i = 0; i < 1; i++) {
        if (pattern[i].close) {
            tp->close_fn(cb, pattern[i].value);
        }
    }
} /* function */
/* ispell,ichartostr, 2R[20.5k]**/



static void mesa_402(Tetra_Params * tp) {
    void * cb = tp->mem_model_cb;

    /* initialisation */
    ulongint i;
    ulongint read_only_remaining = tp->ro_max;
    Tetra_Pattern pattern_setup[ MAX_PATTERNS ];
    Tetra_Pattern pattern[ MAX_PATTERNS ];
    memset (pattern_setup, 0, sizeof(Tetra_Pattern) * MAX_PATTERNS);
    assert ( MAX_PATTERNS >= 2 ) ;
    
    /* initialise pattern 0 */
    i = 0;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 1;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 65536);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    /* initialise pattern 1 */
    i = 1;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (0 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 1) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = (loop_size * 4);
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 80000);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
        p->interval = tp->tile_size / 4; /* abs(a.step) */
        if (p->interval == 0) p->interval = 1;
    }
    Ready_Patterns(tp, pattern_setup, pattern, 2);
    /* start */
    for (i = 0; i < tp->loop_size; i++) {
        Tetra_Pattern * p = NULL;
        int newloc;
                
/* operations */
tp->write_fn(cb, pattern[ 1 ].value + (i * 4), "*ptr4++: Linear, count 1, step 4");
tp->read_fn(cb, pattern[ 0 ].value + 0, "osmesa->clearpixel: Local, count 1");
tp->do_tick_fn(tp, TICK_LOOP_OVERHEAD);

/* generate pattern 0 */
p = &pattern[ 0 ];
newloc = 0;

/* generate pattern 1 */
p = &pattern[ 1 ];
newloc = tp->tiling_flag && ((i % p->interval) == (p->interval - 1));

        if (newloc) {
            if (p->during) {
                p->value = tp->close_fn(cb, p->value);
            }
            if (p->during) {
                int64_t offset = tp->tiling_flag ? ((int64_t) (i+1) * 4) : 0;
                ulongint space = p->space;
                p->value = tp->open_fn(cb, p->value + offset,
                        p->size, &space, p->read_only) - offset;
            }
        } /* if (newloc) */
    } /* for */
   
    for (i = 0; i < 2; i++) {
        if (pattern[i].close) {
            tp->close_fn(cb, pattern[i].value);
        }
    }
} /* function */
/* mesa,clear, 1C 1S+4**/



static void patricia_32_34(Tetra_Params * tp) {
    void * cb = tp->mem_model_cb;

    /* initialisation */
    ulongint i;
    ulongint read_only_remaining = tp->ro_max;
    Tetra_Pattern pattern_setup[ MAX_PATTERNS ];
    Tetra_Pattern pattern[ MAX_PATTERNS ];
    memset (pattern_setup, 0, sizeof(Tetra_Pattern) * MAX_PATTERNS);
    assert ( MAX_PATTERNS >= 1 ) ;
    
    /* initialise pattern 0 */
    i = 0;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 10; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 40;
        }
        if (!1) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 40);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    Ready_Patterns(tp, pattern_setup, pattern, 1);
    /* start */
    for (i = 0; i < tp->loop_size; i++) {
        Tetra_Pattern * p = NULL;
        int newloc;
                
/* operations */
tp->read_fn(cb, pattern[ 0 ].value + 20, "t: LinkedList: size 40, count 10");
tp->read_fn(cb, pattern[ 0 ].value + 33, "t: LinkedList: size 40, count 10");
tp->read_fn(cb, pattern[ 0 ].value + 0, "t: LinkedList: size 40, count 10");
tp->read_fn(cb, pattern[ 0 ].value + 39, "t: LinkedList: size 40, count 10");
tp->read_fn(cb, pattern[ 0 ].value + 16, "t: LinkedList: size 40, count 10");
tp->read_fn(cb, pattern[ 0 ].value + 35, "t: LinkedList: size 40, count 10");
tp->read_fn(cb, pattern[ 0 ].value + 11, "t: LinkedList: size 40, count 10");
tp->read_fn(cb, pattern[ 0 ].value + 23, "t: LinkedList: size 40, count 10");
tp->read_fn(cb, pattern[ 0 ].value + 33, "t: LinkedList: size 40, count 10");
tp->read_fn(cb, pattern[ 0 ].value + 18, "t: LinkedList: size 40, count 10");
tp->do_tick_fn(tp, TICK_LOOP_OVERHEAD);

/* generate pattern 0 */
p = &pattern[ 0 ];
newloc = 1;

        if (newloc) {
            if (p->during) {
                p->value = tp->close_fn(cb, p->value);
            }
            p->value = tp->new_fn(tp, p->value, 40);
            
            if (p->during) {
                int64_t offset = tp->tiling_flag ? ((int64_t) (i+1) * 0) : 0;
                ulongint space = p->space;
                p->value = tp->open_fn(cb, p->value + offset,
                        p->size, &space, p->read_only) - offset;
            }
        } /* if (newloc) */
    } /* for */
   
    for (i = 0; i < 1; i++) {
        if (pattern[i].close) {
            tp->close_fn(cb, pattern[i].value);
        }
    }
} /* function */
/* patricia,main, 10D*/



static void rijndael_94(Tetra_Params * tp) {
    void * cb = tp->mem_model_cb;

    /* initialisation */
    ulongint i;
    ulongint read_only_remaining = tp->ro_max;
    Tetra_Pattern pattern_setup[ MAX_PATTERNS ];
    Tetra_Pattern pattern[ MAX_PATTERNS ];
    memset (pattern_setup, 0, sizeof(Tetra_Pattern) * MAX_PATTERNS);
    assert ( MAX_PATTERNS >= 1 ) ;
    
    /* initialise pattern 0 */
    i = 0;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 224; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 4096;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 4096);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    Ready_Patterns(tp, pattern_setup, pattern, 1);
    /* start */
    for (i = 0; i < tp->loop_size; i++) {
        Tetra_Pattern * p = NULL;
        int newloc;
                
/* operations */
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->read_fn(cb, pattern[ 0 ].value + tp->random_fn(tp, 4096), "*it_tab: Random, within 4096, count 224");
tp->do_tick_fn(tp, TICK_LOOP_OVERHEAD);

/* generate pattern 0 */
p = &pattern[ 0 ];
newloc = 0;

    } /* for */
   
    for (i = 0; i < 1; i++) {
        if (pattern[i].close) {
            tp->close_fn(cb, pattern[i].value);
        }
    }
} /* function */
/* rijndael,encrypt, 224R[4.0k]*/



static void susan_179(Tetra_Params * tp) {
    void * cb = tp->mem_model_cb;

    /* initialisation */
    ulongint i;
    ulongint read_only_remaining = tp->ro_max;
    Tetra_Pattern pattern_setup[ MAX_PATTERNS ];
    Tetra_Pattern pattern[ MAX_PATTERNS ];
    memset (pattern_setup, 0, sizeof(Tetra_Pattern) * MAX_PATTERNS);
    assert ( MAX_PATTERNS >= 3 ) ;
    
    /* initialise pattern 0 */
    i = 0;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 1) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = (loop_size * 1);
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 20000);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
        p->interval = tp->tile_size / 1; /* abs(a.step) */
        if (p->interval == 0) p->interval = 1;
    }
    /* initialise pattern 1 */
    i = 1;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 1) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = (loop_size * 1);
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 20000);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
        p->interval = tp->tile_size / 1; /* abs(a.step) */
        if (p->interval == 0) p->interval = 1;
    }
    /* initialise pattern 2 */
    i = 2;
    {
        int read_only = 0;
        ulongint size = 0;
        ulongint loop_size = tp->loop_size;
        ulongint access_count = 1; /* count */
        Tetra_Pattern * p = &pattern_setup[ i ];

        if (1 && read_only_remaining) {    /* a.Read_Only() */
            read_only_remaining --; 
            read_only = 1;
        }
        if (tp->page_flag) {
            size = tp->page_size;
        } else if (tp->tiling_flag && 0) { /* a.Pattern() == 'S' */
            size = tp->tile_size;
        } else {
            size = 286;
        }
        if (!0) {   /* a.Init_Random() */
            access_count *= loop_size;
        }
        p->score = -tp->worth_copying_fn(cb, size, 
                    access_count, read_only);
        p->size = size;
        p->value = tp->new_fn(tp, 0, 286);
        p->read_only = read_only;
        p->close = 0;
        p->during = 0;
        p->index = i;
    
    }
    Ready_Patterns(tp, pattern_setup, pattern, 3);
    /* start */
    for (i = 0; i < tp->loop_size; i++) {
        Tetra_Pattern * p = NULL;
        int newloc;
                
/* operations */
tp->read_fn(cb, pattern[ 2 ].value + tp->random_fn(tp, 286), "cp: Random, within 286, count 1");
tp->read_fn(cb, pattern[ 1 ].value + (i * 1), "dpt: Linear, count 1, step 1");
tp->read_fn(cb, pattern[ 0 ].value + (i * 1), "ip: Linear, count 1, step 1");
tp->do_tick_fn(tp, TICK_LOOP_OVERHEAD);

/* generate pattern 0 */
p = &pattern[ 0 ];
newloc = tp->tiling_flag && ((i % p->interval) == (p->interval - 1));

        if (newloc) {
            if (p->during) {
                p->value = tp->close_fn(cb, p->value);
            }
            if (p->during) {
                int64_t offset = tp->tiling_flag ? ((int64_t) (i+1) * 1) : 0;
                ulongint space = p->space;
                p->value = tp->open_fn(cb, p->value + offset,
                        p->size, &space, p->read_only) - offset;
            }
        } /* if (newloc) */
/* generate pattern 1 */
p = &pattern[ 1 ];
newloc = tp->tiling_flag && ((i % p->interval) == (p->interval - 1));

        if (newloc) {
            if (p->during) {
                p->value = tp->close_fn(cb, p->value);
            }
            if (p->during) {
                int64_t offset = tp->tiling_flag ? ((int64_t) (i+1) * 1) : 0;
                ulongint space = p->space;
                p->value = tp->open_fn(cb, p->value + offset,
                        p->size, &space, p->read_only) - offset;
            }
        } /* if (newloc) */
/* generate pattern 2 */
p = &pattern[ 2 ];
newloc = 0;

    } /* for */
   
    for (i = 0; i < 3; i++) {
        if (pattern[i].close) {
            tp->close_fn(cb, pattern[i].value);
        }
    }
} /* function */
/* susan,susan_smoothing, 1R[286] 1S+1 1S+1*/


Tetra_Method tetra_methods [] = {
adpcm_113_112_114,
ammp_61_59,
ammp_246_245,
art_122_121,
art_181_182_189_187_185,
art_200_198_199,
art_190,
art_133_132,
bitcount_55,
bitcount_47,
bitcount_45,
bitcount_54,
bitcount_53,
bzip2_404,
bzip2_339,
bzip2_340,
bzip2_406,
bzip2_77,
bzip2_312,
CRC32_31_19_29,
djpeg_331,
djpeg_344,
djpeg_501,
djpeg_496,
fft_234,
gap_1197,
gsm_332,
gsm_115,
gsm_297,
gsm_376_379,
ispell_90,
ispell_198,
ispell_156,
mesa_402,
patricia_32_34,
rijndael_94,
susan_179,
NULL };

const char * tetra_descs [] = {
"adpcm_113_112_114",
"ammp_61_59",
"ammp_246_245",
"art_122_121",
"art_181_182_189_187_185",
"art_200_198_199",
"art_190",
"art_133_132",
"bitcount_55",
"bitcount_47",
"bitcount_45",
"bitcount_54",
"bitcount_53",
"bzip2_404",
"bzip2_339",
"bzip2_340",
"bzip2_406",
"bzip2_77",
"bzip2_312",
"CRC32_31_19_29",
"djpeg_331",
"djpeg_344",
"djpeg_501",
"djpeg_496",
"fft_234",
"gap_1197",
"gsm_332",
"gsm_115",
"gsm_297",
"gsm_376_379",
"ispell_90",
"ispell_198",
"ispell_156",
"mesa_402",
"patricia_32_34",
"rijndael_94",
"susan_179",
NULL };

